# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, SecretStr, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.adobe_analytics_config_v1_config_adobe_analytics_configurations_inner import AdobeAnalyticsConfigV1ConfigAdobeAnalyticsConfigurationsInner
from typing import Optional, Set
from typing_extensions import Self

class AdobeAnalyticsConfigV1Config(BaseModel):
    """
    
    """ # noqa: E501
    var_schema: Optional[StrictStr] = Field(default=None, description="Destination schema. Schema is permanent and cannot be changed after connection creation", alias="schema")
    technical_account_id: Optional[StrictStr] = Field(default=None, description="Technical Account ID from the Service Account (JWT) credentials of your Adobe Project.")
    organization_id: Optional[StrictStr] = Field(default=None, description="Organization ID from the Service Account (JWT) credentials of your Adobe Project.")
    timeframe_months: Optional[Dict[str, Any]] = Field(default=None, description="Number of months' worth of reporting data you'd like to include in your initial sync. This cannot be modified once the connector is created. Default value: `TWELVE` .")
    private_key: Optional[SecretStr] = Field(default=None, description="The complete contents of your private key file including the start and end tags (`----BEGIN PRIVATE KEY----` to `----END PRIVATE KEY----`).")
    client_secret: Optional[SecretStr] = Field(default=None, description="Client Secret from the Service Account (JWT) credentials of your Adobe Project.")
    client_id: Optional[StrictStr] = Field(default=None, description="Client ID from the Service Account (JWT) credentials of your Adobe Project.")
    date_granularity: Optional[Dict[str, Any]] = Field(default=None, description="The aggregation duration you want. Default value: `HOUR` .")
    adobe_analytics_configurations: Optional[List[AdobeAnalyticsConfigV1ConfigAdobeAnalyticsConfigurationsInner]] = Field(default=None, description="The list of configurations of tables you want to sync. The number of tables and their configurations is limited to 5. Required for connector creation.")
    __properties: ClassVar[List[str]] = ["schema", "technical_account_id", "organization_id", "timeframe_months", "private_key", "client_secret", "client_id", "date_granularity", "adobe_analytics_configurations"]

    @field_validator('timeframe_months')
    def timeframe_months_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('TWENTY_FOUR', 'SIX', 'ALL_TIME', 'TWELVE', 'THREE'):
            raise ValueError("must be one of enum values ('TWENTY_FOUR', 'SIX', 'ALL_TIME', 'TWELVE', 'THREE')")
        return value

    @field_validator('date_granularity')
    def date_granularity_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('MONTH', 'QUARTER', 'YEAR', 'HOUR', 'WEEK', 'DAY'):
            raise ValueError("must be one of enum values ('MONTH', 'QUARTER', 'YEAR', 'HOUR', 'WEEK', 'DAY')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AdobeAnalyticsConfigV1Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in adobe_analytics_configurations (list)
        _items = []
        if self.adobe_analytics_configurations:
            for _item in self.adobe_analytics_configurations:
                if _item:
                    _items.append(_item.to_dict())
            _dict['adobe_analytics_configurations'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AdobeAnalyticsConfigV1Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "schema": obj.get("schema"),
            "technical_account_id": obj.get("technical_account_id"),
            "organization_id": obj.get("organization_id"),
            "timeframe_months": obj.get("timeframe_months"),
            "private_key": obj.get("private_key"),
            "client_secret": obj.get("client_secret"),
            "client_id": obj.get("client_id"),
            "date_granularity": obj.get("date_granularity"),
            "adobe_analytics_configurations": [AdobeAnalyticsConfigV1ConfigAdobeAnalyticsConfigurationsInner.from_dict(_item) for _item in obj["adobe_analytics_configurations"]] if obj.get("adobe_analytics_configurations") is not None else None
        })
        return _obj


