# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, SecretStr, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AnaplanConfigV1Config(BaseModel):
    """
    
    """ # noqa: E501
    sync_mode: Optional[Dict[str, Any]] = Field(default=None, description="Whether to sync all exports or specific exports.")
    var_schema: Optional[StrictStr] = Field(default=None, description="Destination schema. Schema is permanent and cannot be changed after connection creation", alias="schema")
    password: Optional[SecretStr] = Field(default=None, description="Your Anaplan password. Must be populated if `auth_mode` is set to `Basic`.")
    selected_exports: Optional[List[StrictStr]] = Field(default=None, description="The list of export IDs in the format `<workspace_id>_<model_id>_<export_id>` that the connector will sync. Must be populated if `sync_mode` is set to `SpecificExports`.")
    certificate: Optional[SecretStr] = Field(default=None, description="The contents of your PEM certificate file. Must be populated if `auth_mode` is set to `Certificate`.")
    auth_mode: Optional[Dict[str, Any]] = Field(default=None, description="The Anaplan authentication method.")
    private_key: Optional[SecretStr] = Field(default=None, description="The contents of your private key file. Must be populated if `auth_mode` is set to `Certificate`.")
    region: Optional[Dict[str, Any]] = Field(default=None, description="Your Anaplan account region")
    username: Optional[StrictStr] = Field(default=None, description="Your Anaplan user ID. Must be populated if `auth_mode` is set to `Basic`.")
    __properties: ClassVar[List[str]] = ["sync_mode", "schema", "password", "selected_exports", "certificate", "auth_mode", "private_key", "region", "username"]

    @field_validator('sync_mode')
    def sync_mode_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('SpecificExports', 'AllExports'):
            raise ValueError("must be one of enum values ('SpecificExports', 'AllExports')")
        return value

    @field_validator('auth_mode')
    def auth_mode_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('Basic', 'Certificate'):
            raise ValueError("must be one of enum values ('Basic', 'Certificate')")
        return value

    @field_validator('region')
    def region_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('EU', 'CAN', 'DEFAULT', 'AUS'):
            raise ValueError("must be one of enum values ('EU', 'CAN', 'DEFAULT', 'AUS')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AnaplanConfigV1Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AnaplanConfigV1Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sync_mode": obj.get("sync_mode"),
            "schema": obj.get("schema"),
            "password": obj.get("password"),
            "selected_exports": obj.get("selected_exports"),
            "certificate": obj.get("certificate"),
            "auth_mode": obj.get("auth_mode"),
            "private_key": obj.get("private_key"),
            "region": obj.get("region"),
            "username": obj.get("username")
        })
        return _obj


