# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, SecretStr, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AwsMskConfigV1Config(BaseModel):
    """
    
    """ # noqa: E501
    var_schema: Optional[StrictStr] = Field(default=None, description="Destination schema. Schema is permanent and cannot be changed after connection creation", alias="schema")
    consumer_group: Optional[StrictStr] = Field(default=None, description="The name of consumer group created for Fivetran.")
    sync_type: Optional[Dict[str, Any]] = Field(default=None, description="The sync type.  Unpacked messages must be valid JSON.")
    sasl_scram512_secret: Optional[SecretStr] = Field(default=None, description="If `sasl_mechanism` is set to `SCRAM_SHA_512`, enter your secret's `saslScram512Key`.")
    schema_registry_credentials_source: Optional[StrictStr] = Field(default=None, description="Schema Registry Credentials source")
    external_id: Optional[StrictStr] = Field(default=None, description="This is the same as your `group_id`. This is required when `sasl_mechanism` is set to `IAM`.")
    message_type: Optional[Dict[str, Any]] = Field(default=None, description="The Message type.")
    sasl_scram512_key: Optional[SecretStr] = Field(default=None, description="If `sasl_mechanism` is set to `SCRAM_SHA_512`, enter your secret's `saslScram512Key`.")
    connection_method: Optional[Dict[str, Any]] = Field(default=None, description="How Fivetran connects to your message brokers in the cluster")
    keystore_password: Optional[SecretStr] = Field(default=None, description="If `security_protocol` is set to `TLS`, enter your `Keystore Password`.")
    servers: Optional[List[StrictStr]] = Field(default=None, description="Comma-separated list of Kafka servers in the `server:port` format.")
    role_arn: Optional[SecretStr] = Field(default=None, description="If `sasl_mechanism` is set to `IAM`, enter your Role ARN")
    sasl_mechanism: Optional[Dict[str, Any]] = Field(default=None, description="If `security_protocol` is set to `SASL`, enter the SASL Mechanism")
    security_protocol: Optional[Dict[str, Any]] = Field(default=None, description="The security protocol for Kafka interaction.")
    schema_registry_secret: Optional[SecretStr] = Field(default=None, description="Schema Registry Secret")
    truststore: Optional[SecretStr] = Field(default=None, description="If `security_protocol` is set to `TLS`, add the `Truststore File` as Base64 encoded string.")
    keystore: Optional[SecretStr] = Field(default=None, description="If `security_protocol` is set to `TLS`, add the `Keystore File` as Base64 encoded string.")
    key_password: Optional[SecretStr] = Field(default=None, description="If `security_protocol` is set to `TLS`, enter your `Key Password`.")
    schema_registry_urls: Optional[List[StrictStr]] = Field(default=None, description="Your schema registry URLs")
    schema_registry_key: Optional[SecretStr] = Field(default=None, description="Schema Registry Key")
    __properties: ClassVar[List[str]] = ["schema", "consumer_group", "sync_type", "sasl_scram512_secret", "schema_registry_credentials_source", "external_id", "message_type", "sasl_scram512_key", "connection_method", "keystore_password", "servers", "role_arn", "sasl_mechanism", "security_protocol", "schema_registry_secret", "truststore", "keystore", "key_password", "schema_registry_urls", "schema_registry_key"]

    @field_validator('sync_type')
    def sync_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('Packed', 'Unpacked'):
            raise ValueError("must be one of enum values ('Packed', 'Unpacked')")
        return value

    @field_validator('message_type')
    def message_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('Text', 'Json', 'Avro', 'Protobuf'):
            raise ValueError("must be one of enum values ('Text', 'Json', 'Avro', 'Protobuf')")
        return value

    @field_validator('connection_method')
    def connection_method_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('privatelink', 'direct'):
            raise ValueError("must be one of enum values ('privatelink', 'direct')")
        return value

    @field_validator('sasl_mechanism')
    def sasl_mechanism_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('IAM', 'SCRAM_SHA_512'):
            raise ValueError("must be one of enum values ('IAM', 'SCRAM_SHA_512')")
        return value

    @field_validator('security_protocol')
    def security_protocol_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('SASL', 'PLAINTEXT', 'TLS'):
            raise ValueError("must be one of enum values ('SASL', 'PLAINTEXT', 'TLS')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AwsMskConfigV1Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AwsMskConfigV1Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "schema": obj.get("schema"),
            "consumer_group": obj.get("consumer_group"),
            "sync_type": obj.get("sync_type"),
            "sasl_scram512_secret": obj.get("sasl_scram512_secret"),
            "schema_registry_credentials_source": obj.get("schema_registry_credentials_source"),
            "external_id": obj.get("external_id"),
            "message_type": obj.get("message_type"),
            "sasl_scram512_key": obj.get("sasl_scram512_key"),
            "connection_method": obj.get("connection_method"),
            "keystore_password": obj.get("keystore_password"),
            "servers": obj.get("servers"),
            "role_arn": obj.get("role_arn"),
            "sasl_mechanism": obj.get("sasl_mechanism"),
            "security_protocol": obj.get("security_protocol"),
            "schema_registry_secret": obj.get("schema_registry_secret"),
            "truststore": obj.get("truststore"),
            "keystore": obj.get("keystore"),
            "key_password": obj.get("key_password"),
            "schema_registry_urls": obj.get("schema_registry_urls"),
            "schema_registry_key": obj.get("schema_registry_key")
        })
        return _obj


