# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.azure_sql_database_config_v1_config import AzureSqlDatabaseConfigV1Config
from openapi_client.models.destination_response import DestinationResponse
from openapi_client.models.setup_test_result_response import SetupTestResultResponse
from typing import Optional, Set
from typing_extensions import Self

class AzureSqlManagedDbWarehouseDestinationResponse(DestinationResponse):
    """
    AzureSqlManagedDbWarehouseDestinationResponse
    """ # noqa: E501
    config: Optional[AzureSqlDatabaseConfigV1Config] = None
    __properties: ClassVar[List[str]] = ["id", "service", "region", "setup_status", "group_id", "time_zone_offset", "setup_tests", "config"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AzureSqlManagedDbWarehouseDestinationResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in setup_tests (list)
        _items = []
        if self.setup_tests:
            for _item in self.setup_tests:
                if _item:
                    _items.append(_item.to_dict())
            _dict['setup_tests'] = _items
        # override the default output from pydantic by calling `to_dict()` of config
        if self.config:
            _dict['config'] = self.config.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AzureSqlManagedDbWarehouseDestinationResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "service": obj.get("service"),
            "region": obj.get("region"),
            "setup_status": obj.get("setup_status"),
            "group_id": obj.get("group_id"),
            "time_zone_offset": obj.get("time_zone_offset"),
            "setup_tests": [SetupTestResultResponse.from_dict(_item) for _item in obj["setup_tests"]] if obj.get("setup_tests") is not None else None,
            "config": AzureSqlDatabaseConfigV1Config.from_dict(obj["config"]) if obj.get("config") is not None else None
        })
        return _obj


