# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, SecretStr, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class BigqueryDbConfigV1Config(BaseModel):
    """
    
    """ # noqa: E501
    secret_key: Optional[SecretStr] = Field(default=None, description="Private key of the customer service account. If specified, your service account will be used to process the data instead of the Fivetran-managed service account.")
    connection_type: Optional[Dict[str, Any]] = Field(default=None, description="Direct or PrivateLink connection")
    project_id: Optional[StrictStr] = Field(default=None, description="BigQuery project ID")
    data_set_name: Optional[StrictStr] = Field(default=None, description="Data set name")
    workspace_same_as_source: Optional[StrictBool] = Field(default=None, description="Use the source dataset as the workspace dataset")
    use_service_account: Optional[StrictBool] = Field(default=None, description="BigQuery use service account; default is false")
    schema_prefix: Optional[StrictStr] = Field(default=None, description="Destination schema prefix. Prefix for each replicated schema. For example with prefix 'x', source schemas 'foo' and 'bar' get replicated as 'x_foo' and 'x_bar'. The prefix is permanent and cannot be changed after connection creation")
    workspace_name: Optional[StrictStr] = Field(default=None, description="Workspace Dataset Name")
    use_workspace: Optional[StrictBool] = Field(default=None, description="Create and drop tables in a query results dataset. Default is false")
    __properties: ClassVar[List[str]] = ["secret_key", "connection_type", "project_id", "data_set_name", "workspace_same_as_source", "use_service_account", "schema_prefix", "workspace_name", "use_workspace"]

    @field_validator('connection_type')
    def connection_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('Directly', 'PrivateLink', 'SshTunnel', 'ProxyAgent'):
            raise ValueError("must be one of enum values ('Directly', 'PrivateLink', 'SshTunnel', 'ProxyAgent')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BigqueryDbConfigV1Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BigqueryDbConfigV1Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "secret_key": obj.get("secret_key"),
            "connection_type": obj.get("connection_type"),
            "project_id": obj.get("project_id"),
            "data_set_name": obj.get("data_set_name"),
            "workspace_same_as_source": obj.get("workspace_same_as_source"),
            "use_service_account": obj.get("use_service_account"),
            "schema_prefix": obj.get("schema_prefix"),
            "workspace_name": obj.get("workspace_name"),
            "use_workspace": obj.get("use_workspace")
        })
        return _obj


