# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, SecretStr, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ConcurConfigV1Config(BaseModel):
    """
    
    """ # noqa: E501
    company_uuid: Optional[StrictStr] = Field(default=None, description="The SAP Concur Company UUID")
    var_schema: Optional[StrictStr] = Field(default=None, description="Destination schema. Schema is permanent and cannot be changed after connection creation", alias="schema")
    login_password: Optional[SecretStr] = Field(default=None, description="The SAP Concur password.")
    company_request_token: Optional[SecretStr] = Field(default=None, description="The SAP Concur Company Request Token")
    auth_mode: Optional[Dict[str, Any]] = Field(default=None, description="The Authentication Mode used by SAP Concur. It can be PasswordGrant or CompanyLevel auth mode")
    client_secret: Optional[SecretStr] = Field(default=None, description="The SAP Concur Client secret.")
    region: Optional[StrictStr] = Field(default=None, description="The region.")
    client_id: Optional[StrictStr] = Field(default=None, description="The SAP Concur Client ID.")
    username: Optional[StrictStr] = Field(default=None, description="The SAP Concur username.")
    __properties: ClassVar[List[str]] = ["company_uuid", "schema", "login_password", "company_request_token", "auth_mode", "client_secret", "region", "client_id", "username"]

    @field_validator('auth_mode')
    def auth_mode_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('CompanyLevel', 'PasswordGrant'):
            raise ValueError("must be one of enum values ('CompanyLevel', 'PasswordGrant')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ConcurConfigV1Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ConcurConfigV1Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "company_uuid": obj.get("company_uuid"),
            "schema": obj.get("schema"),
            "login_password": obj.get("login_password"),
            "company_request_token": obj.get("company_request_token"),
            "auth_mode": obj.get("auth_mode"),
            "client_secret": obj.get("client_secret"),
            "region": obj.get("region"),
            "client_id": obj.get("client_id"),
            "username": obj.get("username")
        })
        return _obj


