# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, SecretStr, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CriteoConfigV1Config(BaseModel):
    """
    
    """ # noqa: E501
    var_schema: Optional[StrictStr] = Field(default=None, description="Destination schema. Schema is permanent and cannot be changed after connection creation", alias="schema")
    report_timezone: Optional[Dict[str, Any]] = Field(default=None, description="Report Timezone")
    timeframe_months: Optional[Dict[str, Any]] = Field(default=None, description="The number of months' worth of reporting data you'd like to include in your initial sync. This cannot be modified once the connector is created.  <br> <strong>NOTE:</strong> The greater number of months means the initial sync will take more time.")
    currency: Optional[Dict[str, Any]] = Field(default=None, description="Currency")
    client_secret: Optional[SecretStr] = Field(default=None, description="Your Criteo client secret key.")
    metrics: Optional[List[StrictStr]] = Field(default=None, description="Metrics")
    client_id: Optional[StrictStr] = Field(default=None, description="Your Criteo Client ID.")
    __properties: ClassVar[List[str]] = ["schema", "report_timezone", "timeframe_months", "currency", "client_secret", "metrics", "client_id"]

    @field_validator('report_timezone')
    def report_timezone_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('Asia/Aden', 'America/Cuiaba', 'UTC -9', 'SCT', 'Africa/Nairobi', 'UTC -3', 'America/Marigot', 'UTC -4', 'UTC -1', 'Asia/Aqtau', 'UTC -2', 'CHAST', 'UTC -7', 'UTC -8', 'Pacific/Kwajalein', 'UTC -5', 'America/El_Salvador', 'UTC -6', 'Asia/Pontianak', 'Africa/Cairo', 'FJT', 'Pacific/Pago_Pago', 'CDT', 'UTC +13:45', 'Africa/Mbabane', 'Asia/Kuching', 'Pacific/Honolulu', 'Pacific/Rarotonga', 'AKST', 'America/Guatemala', 'Australia/Hobart', 'Europe/London', 'America/Belize', 'America/Panama', 'NOVT', 'TAHT', 'UTC +8:30', 'GAMT', 'LINT', 'PONT', 'UYST', 'TFT', 'America/Managua', 'America/Indiana/Petersburg', 'Asia/Yerevan', 'Europe/Brussels', 'MYT', 'JST', 'ACDT', 'FKT', 'GMT', 'Europe/Warsaw', 'America/Chicago', 'CET', 'EASST', 'Europe/Jersey', 'America/Tegucigalpa', 'Europe/Istanbul', 'America/Eirunepe', 'America/Miquelon', 'Europe/Luxembourg', 'America/Argentina/Catamarca', 'UTC +9', 'UTC +7', 'UTC +8', 'AZST', 'Europe/Zaporozhye', 'UTC +1', 'UTC +2', 'UTC +0', 'Atlantic/St_Helena', 'UTC +5', 'UTC +6', 'UTC +3', 'UTC +4', 'Europe/Guernsey', 'Z', 'America/Grand_Turk', 'Asia/Samarkand', 'America/Argentina/Cordoba', 'YEKST', 'Asia/Phnom_Penh', 'IST', 'Africa/Kigali', 'Asia/Almaty', 'Asia/Dubai', 'Europe/Isle_of_Man', 'IRKT', 'America/Araguaina', 'ACT', 'Asia/Novosibirsk', 'America/Argentina/Salta', 'Africa/Tunis', 'Pacific/Fakaofo', 'Africa/Tripoli', 'Africa/Banjul', 'Indian/Comoro', 'RET', 'Pacific/Port_Moresby', 'SGT', 'Antarctica/Syowa', 'Indian/Reunion', 'Pacific/Palau', 'Europe/Kaliningrad', 'FNT', 'America/Montevideo', 'Africa/Windhoek', 'ADT', 'Asia/Karachi', 'Africa/Mogadishu', 'CLST', 'Australia/Perth', 'OMST', 'Asia/Chita', 'Pacific/Easter', 'Antarctica/Davis', 'TJT', 'Antarctica/McMurdo', 'America/Manaus', 'Africa/Freetown', 'Europe/Bucharest', 'America/Argentina/Mendoza', 'Asia/Macau', 'Europe/Malta', 'Pacific/Tahiti', 'HST', 'ANAST', 'Europe/Busingen', 'America/Argentina/Rio_Gallegos', 'UTC+3:30', 'Africa/Malabo', 'Europe/Skopje', 'America/Godthab', 'Europe/Sarajevo', 'ULAST', 'TKT', 'UTC -2:30', 'Africa/Lagos', 'Europe/Rome', 'Indian/Mauritius', 'America/Regina', 'AFT', 'America/Dawson_Creek', 'Africa/Algiers', 'Europe/Mariehamn', 'America/St_Thomas', 'Europe/Zurich', 'America/Anguilla', 'Asia/Dili', 'America/Denver', 'Africa/Bamako', 'Europe/Gibraltar', 'Africa/Conakry', 'UTC +6:30', 'Africa/Lubumbashi', 'PDT', 'America/Havana', 'Asia/Choibalsan', 'Asia/Omsk', 'CKT', 'Europe/Vaduz', 'Asia/Dhaka', 'America/Barbados', 'Atlantic/Cape_Verde', 'Asia/Yekaterinburg', 'TMT', 'UTC +12:45', 'LHST', 'PET', 'Europe/Ljubljana', 'America/Sao_Paulo', 'Asia/Jayapura', 'America/Curacao', 'AWST', 'NZST', 'SAST', 'Asia/Dushanbe', 'CLT', 'America/Guyana', 'America/Guayaquil', 'America/Martinique', 'Europe/Berlin', 'UTC+4:30', 'Europe/Moscow', 'Europe/Chisinau', 'America/Puerto_Rico', 'America/Rankin_Inlet', 'WGST', 'Europe/Stockholm', 'UTC+13:45', 'UTC +5:45', 'Europe/Budapest', 'America/Argentina/Jujuy', 'UTC -3:30', 'Asia/Shanghai', 'Europe/Zagreb', 'UTC+7', 'America/Port_of_Spain', 'UTC+8', 'UTC+9', 'Europe/Helsinki', 'Asia/Beirut', 'Pacific/Bougainville', 'ULAT', 'Africa/Sao_Tome', 'Indian/Chagos', 'America/Cayenne', 'Asia/Yakutsk', 'Pacific/Galapagos', 'Europe/Paris', 'Africa/Ndjamena', 'TOT', 'UTC+3', 'Pacific/Fiji', 'UTC+4', 'America/Rainy_River', 'Indian/Maldives', 'UTC+5', 'PMST', 'UTC+6', 'PGT', 'UTC+0', 'ANAT', 'UTC+1', 'UTC +5:30', 'UTC+2', 'VLAT', 'Asia/Oral', 'America/Yellowknife', 'Pacific/Enderbury', 'America/Juneau', 'America/Indiana/Vevay', 'Asia/Tashkent', 'Asia/Jakarta', 'Africa/Ceuta', 'America/Recife', 'YEKT', 'America/Noronha', 'PHT', 'America/Swift_Current', 'NDT', 'America/Metlakatla', 'Africa/Djibouti', 'America/Paramaribo', 'UTC +10', 'EST', 'UTC +11', 'COT', 'Europe/Simferopol', 'Europe/Sofia', 'Africa/Nouakchott', 'Europe/Prague', 'America/Indiana/Vincennes', 'Antarctica/Mawson', 'UTC+5:30', 'America/Kralendijk', 'VUT', 'Antarctica/Troll', 'Europe/Samara', 'Indian/Christmas', 'UTC +12', 'America/Antigua', 'UTC +13', 'UTC +14', 'Pacific/Gambier', 'America/Inuvik', 'America/Iqaluit', 'Pacific/Funafuti', 'UTC', 'Antarctica/Macquarie', 'BNT', 'America/Moncton', 'Africa/Gaborone', 'Pacific/Chuuk', 'Asia/Pyongyang', 'America/St_Vincent', 'Asia/Gaza', 'UTC+5:45', 'Asia/Qyzylorda', 'AEST', 'WAKT', 'MDT', 'UTC +4:30', 'NFT', 'America/Kentucky/Louisville', 'America/Yakutat', 'MAGT', 'Asia/Ho_Chi_Minh', 'GYT', 'Antarctica/Casey', 'Europe/Copenhagen', 'BOT', 'AMT', 'Africa/Asmara', 'Atlantic/Azores', 'Europe/Vienna', 'Pacific/Pitcairn', 'America/Mazatlan', 'Pacific/Nauru', 'PKT', 'Europe/Tirane', 'Europe/Riga', 'America/Dominica', 'Africa/Abidjan', 'FKST', 'America/Santarem', 'GILT', 'America/Asuncion', 'America/Boise', 'Australia/Currie', 'Pacific/Guam', 'Pacific/Wake', 'Atlantic/Bermuda', 'UTC+6:30', 'America/Costa_Rica', 'America/Dawson', 'Europe/Amsterdam', 'America/Indiana/Knox', 'America/North_Dakota/Beulah', 'CHUT', 'Africa/Accra', 'CHADT', 'Atlantic/Faroe', 'UTC-9:30', 'UTC +10:30', 'America/Maceio', 'Pacific/Apia', 'Pacific/Niue', 'CST', 'Europe/Dublin', 'America/Monterrey', 'America/Nassau', 'America/Jamaica', 'PHOT', 'UTC -10', 'Asia/Bishkek', 'UTC -11', 'America/Atikokan', 'Atlantic/Stanley', 'UTC -12', 'UTC +3:30', 'Indian/Mahe', 'Asia/Aqtobe', 'America/Sitka', 'Asia/Vladivostok', 'BRT', 'FJST', 'Africa/Libreville', 'IRKST', 'Africa/Maputo', 'America/Kentucky/Monticello', 'PYST', 'Africa/El_Aaiun', 'Africa/Ouagadougou', 'TVT', 'America/Aruba', 'America/North_Dakota/Center', 'MHT', 'America/Cayman', 'Asia/Ulaanbaatar', 'Asia/Baghdad', 'ACST', 'Europe/San_Marino', 'America/Indiana/Tell_City', 'BST', 'America/Tijuana', 'AKDT', 'Pacific/Saipan', 'ACWST', 'Africa/Douala', 'America/Chihuahua', 'America/Ojinaga', 'Asia/Hovd', 'America/Anchorage', 'UYT', 'America/Halifax', 'Antarctica/Rothera', 'America/Indiana/Indianapolis', 'Asia/Damascus', 'America/Argentina/San_Luis', 'America/Santiago', 'Asia/Baku', 'UTC+14', 'UTC+12', 'ART', 'BTT', 'UTC+13', 'America/Argentina/Ushuaia', 'Atlantic/Reykjavik', 'Africa/Brazzaville', 'Africa/Porto-Novo', 'America/La_Paz', 'Antarctica/DumontDUrville', 'Asia/Taipei', 'UTC+10', 'UTC+11', 'Asia/Manila', 'UZT', 'Asia/Bangkok', 'Africa/Dar_es_Salaam', 'YAKT', 'Atlantic/Madeira', 'Antarctica/Palmer', 'CEST', 'America/Thunder_Bay', 'Africa/Addis_Ababa', 'AST', 'Europe/Uzhgorod', 'America/Indiana/Marengo', 'America/Creston', 'America/Mexico_City', 'Antarctica/Vostok', 'Asia/Jerusalem', 'KGT', 'Europe/Andorra', 'ICT', 'CXT', 'Asia/Vientiane', 'WAST', 'Pacific/Kiritimati', 'America/Matamoros', 'America/Blanc-Sablon', 'Asia/Riyadh', 'MAGST', 'Pacific/Pohnpei', 'Atlantic/South_Georgia', 'Europe/Lisbon', 'Europe/Oslo', 'Asia/Novokuznetsk', 'IDT', 'UTC+8:30', 'Atlantic/Canary', 'Asia/Kuwait', 'Pacific/Efate', 'Africa/Lome', 'America/Bogota', 'America/Menominee', 'America/Adak', 'EGST', 'Pacific/Norfolk', 'America/Resolute', 'Pacific/Tarawa', 'BRST', 'Africa/Kampala', 'Asia/Krasnoyarsk', 'PST', 'UTC+12:45', 'MMT', 'America/Edmonton', 'Europe/Podgorica', 'UTC+8:45', 'Africa/Bujumbura', 'America/Santo_Domingo', 'Europe/Minsk', 'Pacific/Auckland', 'Africa/Casablanca', 'America/Glace_Bay', 'UTC-12', 'Asia/Qatar', 'Europe/Kiev', 'UTC-10', 'UTC-11', 'Asia/Magadan', 'America/Port-au-Prince', 'America/St_Barthelemy', 'Asia/Ashgabat', 'Africa/Luanda', 'America/Nipigon', 'WAT', 'Asia/Muscat', 'NPT', 'Asia/Bahrain', 'Europe/Vilnius', 'America/Fortaleza', 'America/Hermosillo', 'America/Cancun', 'Africa/Maseru', 'Pacific/Kosrae', 'Africa/Kinshasa', 'Asia/Seoul', 'Australia/Sydney', 'YAKST', 'America/Lima', 'America/St_Lucia', 'Europe/Madrid', 'America/Bahia_Banderas', 'UTC-9', 'America/Montserrat', 'Asia/Brunei', 'KOST', 'America/Cambridge_Bay', 'Indian/Antananarivo', 'Australia/Brisbane', 'Indian/Mayotte', 'Asia/Urumqi', 'MART', 'Europe/Volgograd', 'UTC-5', 'America/Lower_Princes', 'America/Vancouver', 'UTC-6', 'UTC+9:30', 'UTC-7', 'UTC-8', 'Africa/Blantyre', 'America/Rio_Branco', 'UTC-1', 'UTC-2', 'America/Danmarkshavn', 'America/Detroit', 'UTC-3', 'UTC-4', 'DDUT', 'America/Thule', 'Africa/Lusaka', 'Asia/Hong_Kong', 'ALMT', 'PETT', 'America/Argentina/La_Rioja', 'Africa/Dakar', 'America/Tortola', 'America/Porto_Velho', 'Asia/Sakhalin', 'CAST', 'EEST', 'America/Scoresbysund', 'YAPT', 'PETST', 'Asia/Kamchatka', 'Africa/Harare', 'OMSST', 'PWT', 'America/Nome', 'NST', 'LHDT', 'Europe/Tallinn', 'VLAST', 'Africa/Khartoum', 'Africa/Johannesburg', 'GET', 'EAT', 'Africa/Bangui', 'AZT', 'Europe/Belgrade', 'Africa/Bissau', 'UTC -9:30', 'WET', 'Africa/Juba', 'America/Campo_Grande', 'America/Belem', 'MAWT', 'Pacific/Midway', 'GFT', 'America/Bahia', 'America/Goose_Bay', 'MSD', 'MSK', 'WFT', 'America/Pangnirtung', 'PMDT', 'PYT', 'NUT', 'America/Phoenix', 'MST', 'Africa/Niamey', 'America/Whitehorse', 'Pacific/Noumea', 'FET', 'Asia/Tbilisi', 'NZDT', 'UTC-2:30', 'Asia/Makassar', 'America/Argentina/San_Juan', 'VET', 'WGT', 'Asia/Nicosia', 'America/Indiana/Winamac', 'America/Boa_Vista', 'AMST', 'EDT', 'America/Grenada', 'Asia/Khandyga', 'Asia/Kuala_Lumpur', 'Asia/Thimphu', 'UTC-3:30', 'Europe/Bratislava', 'America/Argentina/Tucuman', 'Pacific/Tongatapu', 'NOVST', 'America/New_York', 'AZOST', 'AEDT', 'MUT', 'HKT', 'America/Merida', 'EET', 'America/St_Kitts', 'Arctic/Longyearbyen', 'UTC +9:30', 'America/Caracas', 'AZOT', 'America/Guadeloupe', 'Asia/Hebron', 'Indian/Kerguelen', 'GALT', 'Africa/Monrovia', 'Asia/Ust-Nera', 'MVT', 'Asia/Srednekolymsk', 'America/North_Dakota/New_Salem', 'Asia/Anadyr', 'Australia/Melbourne', 'Asia/Irkutsk', 'America/Winnipeg', 'UTC+10:30', 'Europe/Vatican', 'KRAST', 'EAST', 'Asia/Amman', 'Asia/Tokyo', 'UTC +8:45', 'DAVT', 'America/Toronto', 'Asia/Singapore', 'KST', 'Australia/Lindeman', 'IOT', 'America/Los_Angeles', 'Pacific/Majuro', 'EGT', 'America/Argentina/Buenos_Aires', 'CCT', 'Pacific/Guadalcanal', 'Europe/Athens', 'KRAT', 'Europe/Monaco'):
            raise ValueError("must be one of enum values ('Asia/Aden', 'America/Cuiaba', 'UTC -9', 'SCT', 'Africa/Nairobi', 'UTC -3', 'America/Marigot', 'UTC -4', 'UTC -1', 'Asia/Aqtau', 'UTC -2', 'CHAST', 'UTC -7', 'UTC -8', 'Pacific/Kwajalein', 'UTC -5', 'America/El_Salvador', 'UTC -6', 'Asia/Pontianak', 'Africa/Cairo', 'FJT', 'Pacific/Pago_Pago', 'CDT', 'UTC +13:45', 'Africa/Mbabane', 'Asia/Kuching', 'Pacific/Honolulu', 'Pacific/Rarotonga', 'AKST', 'America/Guatemala', 'Australia/Hobart', 'Europe/London', 'America/Belize', 'America/Panama', 'NOVT', 'TAHT', 'UTC +8:30', 'GAMT', 'LINT', 'PONT', 'UYST', 'TFT', 'America/Managua', 'America/Indiana/Petersburg', 'Asia/Yerevan', 'Europe/Brussels', 'MYT', 'JST', 'ACDT', 'FKT', 'GMT', 'Europe/Warsaw', 'America/Chicago', 'CET', 'EASST', 'Europe/Jersey', 'America/Tegucigalpa', 'Europe/Istanbul', 'America/Eirunepe', 'America/Miquelon', 'Europe/Luxembourg', 'America/Argentina/Catamarca', 'UTC +9', 'UTC +7', 'UTC +8', 'AZST', 'Europe/Zaporozhye', 'UTC +1', 'UTC +2', 'UTC +0', 'Atlantic/St_Helena', 'UTC +5', 'UTC +6', 'UTC +3', 'UTC +4', 'Europe/Guernsey', 'Z', 'America/Grand_Turk', 'Asia/Samarkand', 'America/Argentina/Cordoba', 'YEKST', 'Asia/Phnom_Penh', 'IST', 'Africa/Kigali', 'Asia/Almaty', 'Asia/Dubai', 'Europe/Isle_of_Man', 'IRKT', 'America/Araguaina', 'ACT', 'Asia/Novosibirsk', 'America/Argentina/Salta', 'Africa/Tunis', 'Pacific/Fakaofo', 'Africa/Tripoli', 'Africa/Banjul', 'Indian/Comoro', 'RET', 'Pacific/Port_Moresby', 'SGT', 'Antarctica/Syowa', 'Indian/Reunion', 'Pacific/Palau', 'Europe/Kaliningrad', 'FNT', 'America/Montevideo', 'Africa/Windhoek', 'ADT', 'Asia/Karachi', 'Africa/Mogadishu', 'CLST', 'Australia/Perth', 'OMST', 'Asia/Chita', 'Pacific/Easter', 'Antarctica/Davis', 'TJT', 'Antarctica/McMurdo', 'America/Manaus', 'Africa/Freetown', 'Europe/Bucharest', 'America/Argentina/Mendoza', 'Asia/Macau', 'Europe/Malta', 'Pacific/Tahiti', 'HST', 'ANAST', 'Europe/Busingen', 'America/Argentina/Rio_Gallegos', 'UTC+3:30', 'Africa/Malabo', 'Europe/Skopje', 'America/Godthab', 'Europe/Sarajevo', 'ULAST', 'TKT', 'UTC -2:30', 'Africa/Lagos', 'Europe/Rome', 'Indian/Mauritius', 'America/Regina', 'AFT', 'America/Dawson_Creek', 'Africa/Algiers', 'Europe/Mariehamn', 'America/St_Thomas', 'Europe/Zurich', 'America/Anguilla', 'Asia/Dili', 'America/Denver', 'Africa/Bamako', 'Europe/Gibraltar', 'Africa/Conakry', 'UTC +6:30', 'Africa/Lubumbashi', 'PDT', 'America/Havana', 'Asia/Choibalsan', 'Asia/Omsk', 'CKT', 'Europe/Vaduz', 'Asia/Dhaka', 'America/Barbados', 'Atlantic/Cape_Verde', 'Asia/Yekaterinburg', 'TMT', 'UTC +12:45', 'LHST', 'PET', 'Europe/Ljubljana', 'America/Sao_Paulo', 'Asia/Jayapura', 'America/Curacao', 'AWST', 'NZST', 'SAST', 'Asia/Dushanbe', 'CLT', 'America/Guyana', 'America/Guayaquil', 'America/Martinique', 'Europe/Berlin', 'UTC+4:30', 'Europe/Moscow', 'Europe/Chisinau', 'America/Puerto_Rico', 'America/Rankin_Inlet', 'WGST', 'Europe/Stockholm', 'UTC+13:45', 'UTC +5:45', 'Europe/Budapest', 'America/Argentina/Jujuy', 'UTC -3:30', 'Asia/Shanghai', 'Europe/Zagreb', 'UTC+7', 'America/Port_of_Spain', 'UTC+8', 'UTC+9', 'Europe/Helsinki', 'Asia/Beirut', 'Pacific/Bougainville', 'ULAT', 'Africa/Sao_Tome', 'Indian/Chagos', 'America/Cayenne', 'Asia/Yakutsk', 'Pacific/Galapagos', 'Europe/Paris', 'Africa/Ndjamena', 'TOT', 'UTC+3', 'Pacific/Fiji', 'UTC+4', 'America/Rainy_River', 'Indian/Maldives', 'UTC+5', 'PMST', 'UTC+6', 'PGT', 'UTC+0', 'ANAT', 'UTC+1', 'UTC +5:30', 'UTC+2', 'VLAT', 'Asia/Oral', 'America/Yellowknife', 'Pacific/Enderbury', 'America/Juneau', 'America/Indiana/Vevay', 'Asia/Tashkent', 'Asia/Jakarta', 'Africa/Ceuta', 'America/Recife', 'YEKT', 'America/Noronha', 'PHT', 'America/Swift_Current', 'NDT', 'America/Metlakatla', 'Africa/Djibouti', 'America/Paramaribo', 'UTC +10', 'EST', 'UTC +11', 'COT', 'Europe/Simferopol', 'Europe/Sofia', 'Africa/Nouakchott', 'Europe/Prague', 'America/Indiana/Vincennes', 'Antarctica/Mawson', 'UTC+5:30', 'America/Kralendijk', 'VUT', 'Antarctica/Troll', 'Europe/Samara', 'Indian/Christmas', 'UTC +12', 'America/Antigua', 'UTC +13', 'UTC +14', 'Pacific/Gambier', 'America/Inuvik', 'America/Iqaluit', 'Pacific/Funafuti', 'UTC', 'Antarctica/Macquarie', 'BNT', 'America/Moncton', 'Africa/Gaborone', 'Pacific/Chuuk', 'Asia/Pyongyang', 'America/St_Vincent', 'Asia/Gaza', 'UTC+5:45', 'Asia/Qyzylorda', 'AEST', 'WAKT', 'MDT', 'UTC +4:30', 'NFT', 'America/Kentucky/Louisville', 'America/Yakutat', 'MAGT', 'Asia/Ho_Chi_Minh', 'GYT', 'Antarctica/Casey', 'Europe/Copenhagen', 'BOT', 'AMT', 'Africa/Asmara', 'Atlantic/Azores', 'Europe/Vienna', 'Pacific/Pitcairn', 'America/Mazatlan', 'Pacific/Nauru', 'PKT', 'Europe/Tirane', 'Europe/Riga', 'America/Dominica', 'Africa/Abidjan', 'FKST', 'America/Santarem', 'GILT', 'America/Asuncion', 'America/Boise', 'Australia/Currie', 'Pacific/Guam', 'Pacific/Wake', 'Atlantic/Bermuda', 'UTC+6:30', 'America/Costa_Rica', 'America/Dawson', 'Europe/Amsterdam', 'America/Indiana/Knox', 'America/North_Dakota/Beulah', 'CHUT', 'Africa/Accra', 'CHADT', 'Atlantic/Faroe', 'UTC-9:30', 'UTC +10:30', 'America/Maceio', 'Pacific/Apia', 'Pacific/Niue', 'CST', 'Europe/Dublin', 'America/Monterrey', 'America/Nassau', 'America/Jamaica', 'PHOT', 'UTC -10', 'Asia/Bishkek', 'UTC -11', 'America/Atikokan', 'Atlantic/Stanley', 'UTC -12', 'UTC +3:30', 'Indian/Mahe', 'Asia/Aqtobe', 'America/Sitka', 'Asia/Vladivostok', 'BRT', 'FJST', 'Africa/Libreville', 'IRKST', 'Africa/Maputo', 'America/Kentucky/Monticello', 'PYST', 'Africa/El_Aaiun', 'Africa/Ouagadougou', 'TVT', 'America/Aruba', 'America/North_Dakota/Center', 'MHT', 'America/Cayman', 'Asia/Ulaanbaatar', 'Asia/Baghdad', 'ACST', 'Europe/San_Marino', 'America/Indiana/Tell_City', 'BST', 'America/Tijuana', 'AKDT', 'Pacific/Saipan', 'ACWST', 'Africa/Douala', 'America/Chihuahua', 'America/Ojinaga', 'Asia/Hovd', 'America/Anchorage', 'UYT', 'America/Halifax', 'Antarctica/Rothera', 'America/Indiana/Indianapolis', 'Asia/Damascus', 'America/Argentina/San_Luis', 'America/Santiago', 'Asia/Baku', 'UTC+14', 'UTC+12', 'ART', 'BTT', 'UTC+13', 'America/Argentina/Ushuaia', 'Atlantic/Reykjavik', 'Africa/Brazzaville', 'Africa/Porto-Novo', 'America/La_Paz', 'Antarctica/DumontDUrville', 'Asia/Taipei', 'UTC+10', 'UTC+11', 'Asia/Manila', 'UZT', 'Asia/Bangkok', 'Africa/Dar_es_Salaam', 'YAKT', 'Atlantic/Madeira', 'Antarctica/Palmer', 'CEST', 'America/Thunder_Bay', 'Africa/Addis_Ababa', 'AST', 'Europe/Uzhgorod', 'America/Indiana/Marengo', 'America/Creston', 'America/Mexico_City', 'Antarctica/Vostok', 'Asia/Jerusalem', 'KGT', 'Europe/Andorra', 'ICT', 'CXT', 'Asia/Vientiane', 'WAST', 'Pacific/Kiritimati', 'America/Matamoros', 'America/Blanc-Sablon', 'Asia/Riyadh', 'MAGST', 'Pacific/Pohnpei', 'Atlantic/South_Georgia', 'Europe/Lisbon', 'Europe/Oslo', 'Asia/Novokuznetsk', 'IDT', 'UTC+8:30', 'Atlantic/Canary', 'Asia/Kuwait', 'Pacific/Efate', 'Africa/Lome', 'America/Bogota', 'America/Menominee', 'America/Adak', 'EGST', 'Pacific/Norfolk', 'America/Resolute', 'Pacific/Tarawa', 'BRST', 'Africa/Kampala', 'Asia/Krasnoyarsk', 'PST', 'UTC+12:45', 'MMT', 'America/Edmonton', 'Europe/Podgorica', 'UTC+8:45', 'Africa/Bujumbura', 'America/Santo_Domingo', 'Europe/Minsk', 'Pacific/Auckland', 'Africa/Casablanca', 'America/Glace_Bay', 'UTC-12', 'Asia/Qatar', 'Europe/Kiev', 'UTC-10', 'UTC-11', 'Asia/Magadan', 'America/Port-au-Prince', 'America/St_Barthelemy', 'Asia/Ashgabat', 'Africa/Luanda', 'America/Nipigon', 'WAT', 'Asia/Muscat', 'NPT', 'Asia/Bahrain', 'Europe/Vilnius', 'America/Fortaleza', 'America/Hermosillo', 'America/Cancun', 'Africa/Maseru', 'Pacific/Kosrae', 'Africa/Kinshasa', 'Asia/Seoul', 'Australia/Sydney', 'YAKST', 'America/Lima', 'America/St_Lucia', 'Europe/Madrid', 'America/Bahia_Banderas', 'UTC-9', 'America/Montserrat', 'Asia/Brunei', 'KOST', 'America/Cambridge_Bay', 'Indian/Antananarivo', 'Australia/Brisbane', 'Indian/Mayotte', 'Asia/Urumqi', 'MART', 'Europe/Volgograd', 'UTC-5', 'America/Lower_Princes', 'America/Vancouver', 'UTC-6', 'UTC+9:30', 'UTC-7', 'UTC-8', 'Africa/Blantyre', 'America/Rio_Branco', 'UTC-1', 'UTC-2', 'America/Danmarkshavn', 'America/Detroit', 'UTC-3', 'UTC-4', 'DDUT', 'America/Thule', 'Africa/Lusaka', 'Asia/Hong_Kong', 'ALMT', 'PETT', 'America/Argentina/La_Rioja', 'Africa/Dakar', 'America/Tortola', 'America/Porto_Velho', 'Asia/Sakhalin', 'CAST', 'EEST', 'America/Scoresbysund', 'YAPT', 'PETST', 'Asia/Kamchatka', 'Africa/Harare', 'OMSST', 'PWT', 'America/Nome', 'NST', 'LHDT', 'Europe/Tallinn', 'VLAST', 'Africa/Khartoum', 'Africa/Johannesburg', 'GET', 'EAT', 'Africa/Bangui', 'AZT', 'Europe/Belgrade', 'Africa/Bissau', 'UTC -9:30', 'WET', 'Africa/Juba', 'America/Campo_Grande', 'America/Belem', 'MAWT', 'Pacific/Midway', 'GFT', 'America/Bahia', 'America/Goose_Bay', 'MSD', 'MSK', 'WFT', 'America/Pangnirtung', 'PMDT', 'PYT', 'NUT', 'America/Phoenix', 'MST', 'Africa/Niamey', 'America/Whitehorse', 'Pacific/Noumea', 'FET', 'Asia/Tbilisi', 'NZDT', 'UTC-2:30', 'Asia/Makassar', 'America/Argentina/San_Juan', 'VET', 'WGT', 'Asia/Nicosia', 'America/Indiana/Winamac', 'America/Boa_Vista', 'AMST', 'EDT', 'America/Grenada', 'Asia/Khandyga', 'Asia/Kuala_Lumpur', 'Asia/Thimphu', 'UTC-3:30', 'Europe/Bratislava', 'America/Argentina/Tucuman', 'Pacific/Tongatapu', 'NOVST', 'America/New_York', 'AZOST', 'AEDT', 'MUT', 'HKT', 'America/Merida', 'EET', 'America/St_Kitts', 'Arctic/Longyearbyen', 'UTC +9:30', 'America/Caracas', 'AZOT', 'America/Guadeloupe', 'Asia/Hebron', 'Indian/Kerguelen', 'GALT', 'Africa/Monrovia', 'Asia/Ust-Nera', 'MVT', 'Asia/Srednekolymsk', 'America/North_Dakota/New_Salem', 'Asia/Anadyr', 'Australia/Melbourne', 'Asia/Irkutsk', 'America/Winnipeg', 'UTC+10:30', 'Europe/Vatican', 'KRAST', 'EAST', 'Asia/Amman', 'Asia/Tokyo', 'UTC +8:45', 'DAVT', 'America/Toronto', 'Asia/Singapore', 'KST', 'Australia/Lindeman', 'IOT', 'America/Los_Angeles', 'Pacific/Majuro', 'EGT', 'America/Argentina/Buenos_Aires', 'CCT', 'Pacific/Guadalcanal', 'Europe/Athens', 'KRAT', 'Europe/Monaco')")
        return value

    @field_validator('timeframe_months')
    def timeframe_months_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('TWENTY_FOUR', 'SIX', 'ALL_TIME', 'TWELVE', 'THREE'):
            raise ValueError("must be one of enum values ('TWENTY_FOUR', 'SIX', 'ALL_TIME', 'TWELVE', 'THREE')")
        return value

    @field_validator('currency')
    def currency_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('MXN', 'GTQ', 'CLP', 'UGX', 'HNL', 'ZAR', 'TND', 'BSD', 'IQD', 'TWD', 'RSD', 'DOP', 'MYR', 'XOF', 'GEL', 'UYU', 'MAD', 'OMR', 'AZN', 'SEK', 'KES', 'UAH', 'BTN', 'MZN', 'ARS', 'QAR', 'CNY', 'THB', 'UZS', 'XPF', 'BDT', 'LYD', 'PHP', 'KWD', 'RUB', 'PYG', 'ISK', 'JMD', 'COP', 'USD', 'MKD', 'DZD', 'PAB', 'SGD', 'ETB', 'VEF', 'KGS', 'LAK', 'BND', 'XAF', 'CHF', 'HRK', 'ALL', 'ZMW', 'TZS', 'VND', 'AUD', 'ILS', 'GHS', 'KHR', 'BOB', 'MDL', 'IDR', 'AMD', 'TRY', 'BWP', 'LBP', 'TJS', 'JOD', 'HKD', 'AED', 'RWF', 'EUR', 'DKK', 'CAD', 'BGN', 'MMK', 'NOK', 'MUR', 'GIP', 'RON', 'LKR', 'NGN', 'CZK', 'CRC', 'PKR', 'HTG', 'BHD', 'KZT', 'SZL', 'LTL', 'SAR', 'TTD', 'YER', 'AFN', 'INR', 'KRW', 'NPR', 'JPY', 'MNT', 'PLN', 'AOA', 'GBP', 'HUF', 'MGA', 'BAM', 'EGP', 'MOP', 'NAD', 'NIO', 'PEN', 'NZD', 'BRL'):
            raise ValueError("must be one of enum values ('MXN', 'GTQ', 'CLP', 'UGX', 'HNL', 'ZAR', 'TND', 'BSD', 'IQD', 'TWD', 'RSD', 'DOP', 'MYR', 'XOF', 'GEL', 'UYU', 'MAD', 'OMR', 'AZN', 'SEK', 'KES', 'UAH', 'BTN', 'MZN', 'ARS', 'QAR', 'CNY', 'THB', 'UZS', 'XPF', 'BDT', 'LYD', 'PHP', 'KWD', 'RUB', 'PYG', 'ISK', 'JMD', 'COP', 'USD', 'MKD', 'DZD', 'PAB', 'SGD', 'ETB', 'VEF', 'KGS', 'LAK', 'BND', 'XAF', 'CHF', 'HRK', 'ALL', 'ZMW', 'TZS', 'VND', 'AUD', 'ILS', 'GHS', 'KHR', 'BOB', 'MDL', 'IDR', 'AMD', 'TRY', 'BWP', 'LBP', 'TJS', 'JOD', 'HKD', 'AED', 'RWF', 'EUR', 'DKK', 'CAD', 'BGN', 'MMK', 'NOK', 'MUR', 'GIP', 'RON', 'LKR', 'NGN', 'CZK', 'CRC', 'PKR', 'HTG', 'BHD', 'KZT', 'SZL', 'LTL', 'SAR', 'TTD', 'YER', 'AFN', 'INR', 'KRW', 'NPR', 'JPY', 'MNT', 'PLN', 'AOA', 'GBP', 'HUF', 'MGA', 'BAM', 'EGP', 'MOP', 'NAD', 'NIO', 'PEN', 'NZD', 'BRL')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CriteoConfigV1Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CriteoConfigV1Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "schema": obj.get("schema"),
            "report_timezone": obj.get("report_timezone"),
            "timeframe_months": obj.get("timeframe_months"),
            "currency": obj.get("currency"),
            "client_secret": obj.get("client_secret"),
            "metrics": obj.get("metrics"),
            "client_id": obj.get("client_id")
        })
        return _obj


