# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, SecretStr, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DatabricksConfigV1Config(BaseModel):
    """
    
    """ # noqa: E501
    create_external_tables: Optional[StrictBool] = Field(default=None, description="Whether to create external tables")
    connection_type: Optional[Dict[str, Any]] = None
    controller_id: Optional[StrictStr] = None
    port: Optional[StrictInt] = Field(default=None, description="Server port number")
    catalog: Optional[StrictStr] = Field(default=None, description="Catalog name")
    resource_id: Optional[StrictStr] = Field(default=None, description="This field is currently being introduced to test the Self-serve Private Link functionality")
    enable_remote_execution: Optional[StrictBool] = None
    http_path: Optional[StrictStr] = Field(default=None, description="HTTP path")
    cloud_provider: Optional[Dict[str, Any]] = Field(default=None, description="Databricks deployment cloud")
    server_host_name: Optional[StrictStr] = Field(default=None, description="Server name")
    personal_access_token: Optional[SecretStr] = Field(default=None, description="Personal access token")
    external_location: Optional[StrictStr] = Field(default=None, description="External location to store Delta tables. Default value: `\"\"`  (null). By default, the external tables will reside in the `/{schema}/{table}` path, and if you specify an external location in the `{externalLocation}/{schema}/{table}` path.")
    __properties: ClassVar[List[str]] = ["create_external_tables", "connection_type", "controller_id", "port", "catalog", "resource_id", "enable_remote_execution", "http_path", "cloud_provider", "server_host_name", "personal_access_token", "external_location"]

    @field_validator('connection_type')
    def connection_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('Directly', 'PrivateLink'):
            raise ValueError("must be one of enum values ('Directly', 'PrivateLink')")
        return value

    @field_validator('cloud_provider')
    def cloud_provider_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('AZURE', 'GCP', 'AWS'):
            raise ValueError("must be one of enum values ('AZURE', 'GCP', 'AWS')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DatabricksConfigV1Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DatabricksConfigV1Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "create_external_tables": obj.get("create_external_tables"),
            "connection_type": obj.get("connection_type"),
            "controller_id": obj.get("controller_id"),
            "port": obj.get("port"),
            "catalog": obj.get("catalog"),
            "resource_id": obj.get("resource_id"),
            "enable_remote_execution": obj.get("enable_remote_execution"),
            "http_path": obj.get("http_path"),
            "cloud_provider": obj.get("cloud_provider"),
            "server_host_name": obj.get("server_host_name"),
            "personal_access_token": obj.get("personal_access_token"),
            "external_location": obj.get("external_location")
        })
        return _obj


