# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DoubleClickPublishersConfigV1Config(BaseModel):
    """
    
    """ # noqa: E501
    var_schema: Optional[StrictStr] = Field(default=None, description="Destination schema. Schema is permanent and cannot be changed after connection creation", alias="schema")
    network_code: Optional[StrictInt] = Field(default=None, description="Network code is a unique, numeric identifier for your Ad Manager network.")
    custom_field_ids: Optional[List[StrictInt]] = Field(default=None, description="The list of custom field IDs included in the report. Custom fields can only be selected with their corresponding dimensions.")
    dimension_attributes: Optional[List[StrictStr]] = Field(default=None, description="Dimension attributes provide additional fields associated with a Dimension. Dimension attributes can only be selected with their corresponding Dimensions.")
    ad_unit_view: Optional[Dict[str, Any]] = Field(default=None, description="Ad unit view for the report.")
    columns: Optional[List[StrictStr]] = Field(default=None, description="Columns provide all trafficking statistics and revenue information available for the chosen Dimensions.")
    timeframe_months: Optional[Dict[str, Any]] = Field(default=None, description="Number of months' worth of reporting data you'd like to include in your initial sync. A change of this value will trigger a re-sync for enabled reports during the next connector sync.")
    table: Optional[StrictStr] = Field(default=None, description="Destination table. Table is permanent and cannot be changed after connection creation")
    dimensions: Optional[List[StrictStr]] = Field(default=None, description="Report dimensions to include in the sync. The `date` dimension is mandatory for all the report types.")
    __properties: ClassVar[List[str]] = ["schema", "network_code", "custom_field_ids", "dimension_attributes", "ad_unit_view", "columns", "timeframe_months", "table", "dimensions"]

    @field_validator('ad_unit_view')
    def ad_unit_view_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('HIERARCHICAL', 'TOP_LEVEL', 'FLAT'):
            raise ValueError("must be one of enum values ('HIERARCHICAL', 'TOP_LEVEL', 'FLAT')")
        return value

    @field_validator('timeframe_months')
    def timeframe_months_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('TWENTY_FOUR', 'SIX', 'ALL_TIME', 'TWELVE', 'THREE'):
            raise ValueError("must be one of enum values ('TWENTY_FOUR', 'SIX', 'ALL_TIME', 'TWELVE', 'THREE')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DoubleClickPublishersConfigV1Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DoubleClickPublishersConfigV1Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "schema": obj.get("schema"),
            "network_code": obj.get("network_code"),
            "custom_field_ids": obj.get("custom_field_ids"),
            "dimension_attributes": obj.get("dimension_attributes"),
            "ad_unit_view": obj.get("ad_unit_view"),
            "columns": obj.get("columns"),
            "timeframe_months": obj.get("timeframe_months"),
            "table": obj.get("table"),
            "dimensions": obj.get("dimensions")
        })
        return _obj


