# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, SecretStr, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GithubConfigV1Config(BaseModel):
    """
    
    """ # noqa: E501
    sync_mode: Optional[Dict[str, Any]] = Field(default=None, description="Whether to sync all repositories or specific repositories.")
    var_schema: Optional[StrictStr] = Field(default=None, description="Destination schema. Schema is permanent and cannot be changed after connection creation", alias="schema")
    use_webhooks: Optional[StrictBool] = Field(default=None, description="Set to `true` to capture deletes.")
    pat: Optional[SecretStr] = Field(default=None, description="The `Personal Access Token` generated in Github.")
    repositories: Optional[List[StrictStr]] = Field(default=None, description="Specific Repository IDs to sync. Must be populated if `syncMode` is set to `SpecificRepositories`.")
    auth_mode: Optional[Dict[str, Any]] = Field(default=None, description="Authorization type.")
    username: Optional[StrictStr] = Field(default=None, description="`Login` of your GitHub profile.")
    __properties: ClassVar[List[str]] = ["sync_mode", "schema", "use_webhooks", "pat", "repositories", "auth_mode", "username"]

    @field_validator('sync_mode')
    def sync_mode_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('SpecificRepositories', 'AllRepositories'):
            raise ValueError("must be one of enum values ('SpecificRepositories', 'AllRepositories')")
        return value

    @field_validator('auth_mode')
    def auth_mode_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('PersonalAccessToken', 'OAuth'):
            raise ValueError("must be one of enum values ('PersonalAccessToken', 'OAuth')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GithubConfigV1Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GithubConfigV1Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sync_mode": obj.get("sync_mode"),
            "schema": obj.get("schema"),
            "use_webhooks": obj.get("use_webhooks"),
            "pat": obj.get("pat"),
            "repositories": obj.get("repositories"),
            "auth_mode": obj.get("auth_mode"),
            "username": obj.get("username")
        })
        return _obj


