# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.google_ads_config_v1_config_reports_inner import GoogleAdsConfigV1ConfigReportsInner
from typing import Optional, Set
from typing_extensions import Self

class GoogleAdsConfigV1Config(BaseModel):
    """
    
    """ # noqa: E501
    sync_mode: Optional[Dict[str, Any]] = Field(default=None, description="Whether to sync all accounts or specific accounts.")
    var_schema: Optional[StrictStr] = Field(default=None, description="Destination schema. Schema is permanent and cannot be changed after connection creation", alias="schema")
    reports: Optional[List[GoogleAdsConfigV1ConfigReportsInner]] = Field(default=None, description="The list of reports. Each report corresponds to a table within the schema to which connector will sync the data.")
    manager_accounts: Optional[List[StrictStr]] = Field(default=None, description="The list of the Manager Account IDs whose clients will be synced. Must be populated if `sync_mode` is set to `ManagerAccounts`.")
    timeframe_months: Optional[Dict[str, Any]] = Field(default=None, description="The number of months' worth of reporting data you'd like to include in your initial sync. A change of this value will trigger a re-sync for enabled custom and prebuilt reports during the next connector sync. Default value: `TWELVE`.")
    accounts: Optional[List[StrictStr]] = Field(default=None, description="The list of Account IDs to sync. Must be populated if `sync_mode` is set to `SpecificAccounts`.")
    customer_id: Optional[StrictStr] = Field(default=None, description="ID of the customer, can be retrieved from your AdWords dashboard.")
    conversion_window_size: Optional[StrictInt] = Field(default=None, description="A period of time in days during which a conversion is recorded.")
    __properties: ClassVar[List[str]] = ["sync_mode", "schema", "reports", "manager_accounts", "timeframe_months", "accounts", "customer_id", "conversion_window_size"]

    @field_validator('sync_mode')
    def sync_mode_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('ManagerAccounts', 'AllAccounts', 'SpecificAccounts'):
            raise ValueError("must be one of enum values ('ManagerAccounts', 'AllAccounts', 'SpecificAccounts')")
        return value

    @field_validator('timeframe_months')
    def timeframe_months_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('TWENTY_FOUR', 'SIX', 'ALL_TIME', 'TWELVE', 'THREE'):
            raise ValueError("must be one of enum values ('TWENTY_FOUR', 'SIX', 'ALL_TIME', 'TWELVE', 'THREE')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GoogleAdsConfigV1Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in reports (list)
        _items = []
        if self.reports:
            for _item in self.reports:
                if _item:
                    _items.append(_item.to_dict())
            _dict['reports'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GoogleAdsConfigV1Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sync_mode": obj.get("sync_mode"),
            "schema": obj.get("schema"),
            "reports": [GoogleAdsConfigV1ConfigReportsInner.from_dict(_item) for _item in obj["reports"]] if obj.get("reports") is not None else None,
            "manager_accounts": obj.get("manager_accounts"),
            "timeframe_months": obj.get("timeframe_months"),
            "accounts": obj.get("accounts"),
            "customer_id": obj.get("customer_id"),
            "conversion_window_size": obj.get("conversion_window_size")
        })
        return _obj


