# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, SecretStr, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.aws_lambda_config_v1_config_custom_payloads_inner import AwsLambdaConfigV1ConfigCustomPayloadsInner
from openapi_client.models.azure_function_config_v1_config_secrets_list_inner import AzureFunctionConfigV1ConfigSecretsListInner
from typing import Optional, Set
from typing_extensions import Self

class GoogleCloudFunctionConfigV1Config(BaseModel):
    """
    
    """ # noqa: E501
    var_schema: Optional[StrictStr] = Field(default=None, description="Destination schema. Schema is permanent and cannot be changed after connection creation", alias="schema")
    custom_payloads: Optional[List[AwsLambdaConfigV1ConfigCustomPayloadsInner]] = Field(default=None, description="The list of key-value pairs that can be used to specify custom information to the function at runtime.")
    secrets_list: Optional[List[AzureFunctionConfigV1ConfigSecretsListInner]] = Field(default=None, description="The list of secrets that should be passed to the function at runtime.")
    function_trigger: Optional[SecretStr] = Field(default=None, description="The trigger URL of the cloud function.")
    service_account_email: Optional[StrictStr] = Field(default=None, description="Provide Invoker role to this service account.")
    secrets: Optional[SecretStr] = Field(default=None, description="The secrets that should be passed to the function at runtime.")
    __properties: ClassVar[List[str]] = ["schema", "custom_payloads", "secrets_list", "function_trigger", "service_account_email", "secrets"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GoogleCloudFunctionConfigV1Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in custom_payloads (list)
        _items = []
        if self.custom_payloads:
            for _item in self.custom_payloads:
                if _item:
                    _items.append(_item.to_dict())
            _dict['custom_payloads'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in secrets_list (list)
        _items = []
        if self.secrets_list:
            for _item in self.secrets_list:
                if _item:
                    _items.append(_item.to_dict())
            _dict['secrets_list'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GoogleCloudFunctionConfigV1Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "schema": obj.get("schema"),
            "custom_payloads": [AwsLambdaConfigV1ConfigCustomPayloadsInner.from_dict(_item) for _item in obj["custom_payloads"]] if obj.get("custom_payloads") is not None else None,
            "secrets_list": [AzureFunctionConfigV1ConfigSecretsListInner.from_dict(_item) for _item in obj["secrets_list"]] if obj.get("secrets_list") is not None else None,
            "function_trigger": obj.get("function_trigger"),
            "service_account_email": obj.get("service_account_email"),
            "secrets": obj.get("secrets")
        })
        return _obj


