# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.google_search_ads360_config_v1_config_reports_inner import GoogleSearchAds360ConfigV1ConfigReportsInner
from typing import Optional, Set
from typing_extensions import Self

class GoogleSearchAds360ConfigV1Config(BaseModel):
    """
    
    """ # noqa: E501
    var_schema: Optional[StrictStr] = Field(default=None, description="Destination schema. Schema is permanent and cannot be changed after connection creation", alias="schema")
    reports: Optional[List[GoogleSearchAds360ConfigV1ConfigReportsInner]] = Field(default=None, description="The list of reports. Each report corresponds to a table within the schema to which connector syncs the data.")
    advertisers_sync_mode: Optional[Dict[str, Any]] = Field(default=None, description="Whether to sync all or specific advertisers.")
    advertisers: Optional[List[StrictStr]] = Field(default=None, description="Specific advertisers to sync. Must be populated if `advertisersSyncMode` is set to `SPECIFIC_ADVERTISERS`.")
    timeframe_months: Optional[Dict[str, Any]] = Field(default=None, description="Number of months' worth of reporting data you'd like to include in your initial sync. A change of this value will trigger a re-sync for enabled reports during the next connector sync. ")
    accounts: Optional[List[StrictStr]] = Field(default=None, description="Specific accounts to sync. Must be populated if `accountsSyncMode` is set to `SPECIFIC_ACCOUNTS`.")
    accounts_sync_mode: Optional[Dict[str, Any]] = Field(default=None, description="Whether to sync all accounts or specific.")
    __properties: ClassVar[List[str]] = ["schema", "reports", "advertisers_sync_mode", "advertisers", "timeframe_months", "accounts", "accounts_sync_mode"]

    @field_validator('advertisers_sync_mode')
    def advertisers_sync_mode_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('SPECIFIC_ADVERTISERS', 'ALL_ADVERTISERS'):
            raise ValueError("must be one of enum values ('SPECIFIC_ADVERTISERS', 'ALL_ADVERTISERS')")
        return value

    @field_validator('timeframe_months')
    def timeframe_months_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('TWENTY_FOUR', 'SIX', 'ALL_TIME', 'TWELVE', 'THREE'):
            raise ValueError("must be one of enum values ('TWENTY_FOUR', 'SIX', 'ALL_TIME', 'TWELVE', 'THREE')")
        return value

    @field_validator('accounts_sync_mode')
    def accounts_sync_mode_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('ALL_ACCOUNTS', 'SPECIFIC_ACCOUNTS'):
            raise ValueError("must be one of enum values ('ALL_ACCOUNTS', 'SPECIFIC_ACCOUNTS')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GoogleSearchAds360ConfigV1Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in reports (list)
        _items = []
        if self.reports:
            for _item in self.reports:
                if _item:
                    _items.append(_item.to_dict())
            _dict['reports'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GoogleSearchAds360ConfigV1Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "schema": obj.get("schema"),
            "reports": [GoogleSearchAds360ConfigV1ConfigReportsInner.from_dict(_item) for _item in obj["reports"]] if obj.get("reports") is not None else None,
            "advertisers_sync_mode": obj.get("advertisers_sync_mode"),
            "advertisers": obj.get("advertisers"),
            "timeframe_months": obj.get("timeframe_months"),
            "accounts": obj.get("accounts"),
            "accounts_sync_mode": obj.get("accounts_sync_mode")
        })
        return _obj


