# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GoogleSearchAds360ConfigV1ConfigReportsInner(BaseModel):
    """
    The list of reports. Each report corresponds to a table within the schema to which connector syncs the data.
    """ # noqa: E501
    attributes: Optional[List[Dict[str, Any]]] = Field(default=None, description="The report dimensions included to sync.")
    metrics: Optional[List[Dict[str, Any]]] = Field(default=None, description="The report dimensions included to sync.")
    report_type: Optional[Dict[str, Any]] = Field(default=None, description="The type of report")
    table: Optional[StrictStr] = Field(default=None, description="The name of a table within the schema to which connector syncs the data of a given report.")
    __properties: ClassVar[List[str]] = ["attributes", "metrics", "report_type", "table"]

    @field_validator('attributes')
    def attributes_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        for i in value:
            if i not in ('CTR', 'BING_ADS_BUDGET_TYPE', 'PRODUCT_GROUP_PARTITION_TYPE', 'NEGATIVE_CAMPAIGN_KEYWORD_TEXT', 'IMPR', 'CAMPAIGN_TYPE', 'CAMPAIGN_TARGET_ID', 'EFFECTIVE_PROVINCE_TARGETS', 'FLOODLIGHT_CONFIGURATION_ID', 'DISPLAY_BUDGET_LOST_IMPRESSION_SHARE', 'HIGH_POSITION', 'NETWORK_TARGET', 'ACCOUNT_TIMEZONE', 'LOCATION_DETAILS', 'PAID_AND_ORGANIC_CTR', 'AD_GROUP_MOBILE_BID_ADJUSTMENT', 'CONVERSION_VISIT_TIMESTAMP', 'FLOODLIGHT_EVENT_REQUEST_STRING', 'PRODUCT_GTIN', 'CAMPAIGN_LABELS', 'ADVERTISER_CONVERSION_ID', 'ADVERTISER', 'DYNAMIC_SEARCH_ADS_TARGET_CPC_BID', 'EXCLUDED_PROVINCE_TARGETS', 'ACCOUNT_CURRENCY_CODE', 'CAMPAIGN_ID', 'AD_GROUP_LABELS', 'AD', 'NEGATIVE_AD_GROUP_KEYWORD_MATCH_TYPE', 'DYNAMIC_SEARCH_ADS_TARGET_LANDING_PAGE_URL', 'LEAD_REVENUE_FROM_UNITS_SOLD', 'FLOODLIGHT_GROUP_CONVERSION_TYPE', 'PRODUCT_GROUP_ID', 'PRODUCT_AVERAGE_UNIT_PRICE', 'EFFECTIVE_PRODUCT_TARGET_MAX_CPC', 'AD_DESCRIPTION_2', 'AD_GROUP_END_DATE', 'VISIT_NETWORK_TYPE', 'LEAD_GROSS_PROFIT_FROM_UNITS_SOLD', 'AD_DESCRIPTION_1', 'DFA_ACTIONS_CROSS_ENV', 'PRODUCT_TARGET_MAX_CPC', 'AD_TYPE', 'PRODUCT_TITLE', 'METRO_TARGETS', 'KEYWORD_NEAR_MATCH_ENABLED', 'SEARCH_RANK_LOST_IMPRESSION_SHARE', 'PAID_AVG_POS', 'AD_GROUP_TABLET_BID_ADJUSTMENT', 'CROSS_SELL_AVERAGE_UNIT_PRICE', 'AD_GROUP', 'SITELINK_CLICKSERVER_URL', 'BID_STRATEGY_MAX_BID', 'PRODUCT_GROUP_MAX_BID', 'AGENCY_ID', 'CLICKS_WITH_FEED_ITEM_SHOWING', 'AD_GROUP_TARGET_ID', 'DYNAMIC_SEARCH_ADS_TARGET_CONDITIONS', 'PRODUCT_TARGET_LABELS', 'FLOODLIGHT_ORIGINAL_REVENUE', 'PRODUCT_AGE_GROUP', 'FLOODLIGHT_ORDER_ID', 'EXCLUDED_METRO_TARGETS', 'CITY_TARGETS', 'FLOODLIGHT_ACTIVITY', 'KEYWORD_LANDING_PAGE', 'PRODUCT_UNITS_SOLD', 'EXCLUDED_COUNTRY_TARGETS', 'PAID_AND_ORGANIC_CLICKS', 'AD_GROUP_ID', 'CONVERSION_ID', 'LOCATION_TARGET_BID_MODIFIER', 'CAMPAIGN_START_DATE', 'ENGINE_REMARKETING_LIST_TARGET_ALL', 'PRODUCT_CATEGORY_LEVEL_3', 'PRODUCT_CATEGORY_LEVEL_2', 'PRODUCT_CATEGORY_LEVEL_1', 'VISITS', 'MONTH_START', 'LEAD_AVERAGE_UNIT_PRICE', 'CONVERSION_SEARCH_TERM', 'CALL_IS_TRACKED', 'AVG_POS', 'CONVERSION_REVENUE', 'PRODUCT_CATEGORY_LEVEL_5', 'AD_GROUP_SEARCH_MAX_CPC', 'PRODUCT_CATEGORY_LEVEL_4', 'VISIT_REFERRER', 'DISPLAY_IMPRESSION_SHARE', 'CREATION_TIMESTAMP', 'CONVERSION_VISIT_EXTERNAL_CLICK_ID', 'SEARCH_RANK_LOST_TOP_IMPRESSION_SHARE', 'FLOODLIGHT_ACTIVITY_ID', 'ORGANIC_CLICKS', 'AD_GROUP_DESKTOP_BID_ADJUSTMENT', 'CAMPAIGN_DESKTOP_BID_ADJUSTMENT', 'CONVERSION_TIMESTAMP', 'EFFECTIVE_KEYWORD_MAX_CPC', 'NEGATIVE_CAMPAIGN_KEYWORD_MATCH_TYPE', 'PAID_COST_PER_CLICK', 'CONVERSION_QUANTITY', 'KEYWORD_MAX_CPC', 'CONVERSION_LAST_MODIFIED_TIMESTAMP', 'PRODUCT_GROUP_MAX_CPC', 'PRODUCT_TARGET_FILTER', 'ADWORDS_CONVERSIONS', 'SEARCH_BUDGET_LOST_ABSOLUTE_TOP_IMPRESSION_SHARE', 'LANGUAGE_TARGETS', 'ACCOUNT', 'ERS_TARGET', 'LOCATION_TARGET_NAME', 'AGE_TARGET_AGE_RANGE', 'LOCATION_CATEGORY', 'COUNTRY_TARGETS', 'DFA_REVENUE', 'PRODUCT_LANDING_PAGE_URL', 'PRODUCT_GROUP', 'PRODUCT_GROUP_CLICKSERVER_URL', 'ABSOLUTE_TOP_IMPRESSION_PERCENTAGE', 'ENGINE_STATUS', 'AD_GROUP_EXACT_MAX_CPC', 'LOCATION_BUSINESS_NAME', 'PRODUCT_TARGET_MAX_BID', 'NEGATIVE_CAMPAIGN_KEYWORD_ID', 'ADVERTISER_ID', 'AGE_TARGET_BID_MODIFIER', 'KEYWORD_URL_PARAMS', 'NEGATIVE_CAMPAIGN_TARGET_ID', 'PRODUCT_STORE_ID', 'LEAD_UNITS_SOLD', 'EFFECTIVE_METRO_TARGETS', 'EXCLUDED_CITY_TARGETS', 'PRODUCT_GENDER', 'CONVERSION_DATE', 'KEYWORD_MIN_BID', 'PRODUCT_TYPE_LEVEL_1', 'PRODUCT_TARGET_LANDING_PAGE', 'KEYWORD_TEXT', 'PRODUCT_TYPE_LEVEL_2', 'ACCOUNT_TYPE', 'PRODUCT_TYPE_LEVEL_3', 'YAHOO_JAPAN_BID_STRATEGY', 'PRODUCT_TYPE_LEVEL_4', 'PRODUCT_TYPE_LEVEL_5', 'CALL_CONVERSION_TRACKER_ID', 'AD_GROUP_TYPE', 'VISIT_DATE', 'DFA_ACTIONS', 'EFFECTIVE_PRODUCT_GROUP_MAX_CPC', 'DFA_TRANSACTIONS', 'KEYWORD_MATCH_TYPE', 'FLOODLIGHT_ACTIVITY_TARGET_IDS', 'LEAD_GROSS_PROFIT_MARGIN', 'FEED_TYPE', 'FLOODLIGHT_OPTIMIZATION_ENABLED', 'SEARCH_IMPRESSION_SHARE', 'DAILY_BUDGET', 'AD_GROUP_CONTENT_MAX_CPC', 'PRODUCT_MPN', 'ADVERTISER_CURRENCY_CODE', 'ADWORDS_BID_STRATEGY', 'AGENCY', 'PRODUCT_CONDITION', 'SITELINK_DISPLAY_TEXT', 'PRODUCT_TARGET_ENGINE_ID', 'ORGANIC_QUERIES', 'EFFECTIVE_LABELS', 'SEARCH_ABSOLUTE_TOP_IMPRESSION_SHARE', 'LOCATION_FILTER', 'SEARCH_TOP_IMPRESSION_SHARE', 'AD_ID', 'AD_GROUP_ENGINE_ID', 'BID_STRATEGY_MIN_BID', 'PRODUCT_PATTERN', 'AD_LANDING_PAGE', 'AD_GROUP_BROAD_MAX_CPC', 'VISIT_SEARCH_QUERY', 'PAID_IMPRESSIONS', 'FLOODLIGHT_ACTIVITY_TAG', 'CAMPAIGN_STATUS', 'AD_GROUP_PHRASE_MAX_CPC', 'TOP_OF_PAGE_BID_AVG', 'CALL_COUNTRY_CODE', 'CROSS_SELL_GROSS_FROM_UNITS_SOLD', 'PRODUCT_CUSTOM_LABEL_0', 'PRODUCT_CUSTOM_LABEL_1', 'PRODUCT_CUSTOM_LABEL_2', 'PRODUCT_CUSTOM_LABEL_3', 'DYNAMIC_SEARCH_ADS_TARGET_COVERAGE', 'PRODUCT_CUSTOM_LABEL_4', 'AD_ENGINE_ID', 'SEARCH_BUDGET_LOST_IMPRESSION_SHARE', 'DFA_NETWORK_TIMEZONE', 'PRODUCT_LANGUAGE', 'AVG_CPC', 'CAMPAIGN_END_DATE', 'PRODUCT_COST_OF_GOODS_SOLD', 'VISIT_TIMESTAMP', 'ORGANIC_AVG_POS', 'EFFECTIVE_CITY_TARGETS', 'GENDER_TARGET_BID_MODIFIER', 'TOP_OF_PAGE_BID_CURRENT', 'PRODUCT_SIZE', 'AD_ROTATION', 'PROVINCE_TARGETS', 'PRODUCT_TARGET_ID', 'INVENTORY_ACCOUNT_ID', 'BING_ADS_LANGUAGE', 'UNCLASSIFIED_TARGET_TYPE', 'DFA_NETWORK_ID', 'QUALITY_SCORE_AVG', 'FLOODLIGHT_GROUP_TAG', 'LAST_MODIFIED_TIMESTAMP', 'LOW_POSITION', 'AD_GROUP_STATUS', 'BID_STRATEGY_ID', 'BING_KEYWORD_PARAM_2', 'AVG_CPM', 'PAID_CLICKS', 'CROSS_SELL_COST_OF_GOODS_SOLD', 'PRODUCT_CHANNEL_EXCLUSIVITY', 'FLOODLIGHT_GROUP_ID', 'BING_KEYWORD_PARAM_3', 'NEGATIVE_AD_GROUP_KEYWORD_ID', 'PAID_CTR', 'PRODUCT_ITEM_GROUP_ID', 'PRODUCT_GROUP_MIN_BID', 'DFA_ADVERTISER_ID', 'CAMPAIGN_ENGINE_ID', 'GOOGLE_ANALYTICS_TIMEZONE', 'PRODUCT_CHANNEL', 'CLICKS', 'SEARCH_BUDGET_LOST_TOP_IMPRESSION_SHARE', 'PRODUCT_COUNTRY', 'ENGINE_REMARKETING_LIST', 'CONVERSION_TYPE', 'NEGATIVE_AD_GROUP_TARGET_ID', 'EFFECTIVE_DEVICE_TARGETS', 'EFFECTIVE_COUNTRY_TARGETS', 'AD_HEADLINE', 'ORGANIC_CTR', 'CAMPAIGN', 'CALL_CONVERSION_TRACKER', 'VISIT_EXTERNAL_CLICK_ID', 'APP_ID', 'SEARCH_QUERY', 'ROAS_TARGET', 'IS_DISPLAY_KEYWORD', 'PRODUCT_AVAILABILITY', 'PRODUCT_PRICE', 'PRODUCT_CATEGORY', 'ACCOUNT_ENGINE_ID', 'CROSS_SELL_REVENUE_FROM_UNITS_SOLD', 'PRODUCT_MATERIAL', 'LEAD_COST_OF_GOODS_SOLD', 'PRODUCT_SALE_PRICE', 'ACCOUNT_ID', 'APP_STORE', 'EFFECTIVE_BID_STRATEGY', 'FEED_ITEM_ID', 'BING_ADS_AD_DISTRIBUTIONS', 'DEVICE_TARGETS', 'QUALITY_SCORE_CURRENT', 'SERP_TYPE', 'CAMPAIGN_MOBILE_BID_ADJUSTMENT', 'STATUS', 'TOP_IMPRESSION_PERCENTAGE', 'AD_LABELS', 'MONTHLY_SPEND_TARGET', 'CROSS_SELL_GROSS_PROFIT_MARGIN', 'CONVERSION_VISIT_ID', 'BID_STRATEGY_GOAL', 'PRODUCT_GROUP_LANDING_PAGE', 'ADWORDS_VIEW_THROUGH_CONVERSIONS', 'CONVERSION_ATTRIBUTION_TYPE', 'EFFECTIVE_BID_STRATEGY_ID', 'CAMPAIGN_TABLET_BID_ADJUSTMENT', 'PRODUCT_REVENUE_FROM_UNITS_SOLD', 'YAHOO_GEO_TARGETS', 'PAID_AND_ORGANIC_QUERIES', 'DFA_REVENUE_CROSS_ENV', 'PRODUCT_TARGET_MIN_BID', 'DATE', 'BID_STRATEGY', 'VISIT_ID', 'DELIVERY_METHOD', 'AD_DISPLAY_URL', 'SEARCH_RANK_LOST_ABSOLUTE_TOP_IMPRESSION_SHARE', 'MONTHLY_BUDGET', 'AD_HEADLINE_2', 'BID_STRATEGY_INHERITED', 'KEYWORD_ENGINE_ID', 'SITELINK_LANDING_PAGE_URL', 'AD_HEADLINE_3', 'AD_PATH_FIELD_2', 'KEYWORD_ID', 'AD_PATH_FIELD_1', 'PRODUCT_COLOR', 'UNCLASSIFIED_TARGET_NAME', 'FEED_ID', 'AD_PROMOTION_LINE', 'FLOODLIGHT_GROUP', 'GENDER_TARGET_GENDER_TYPE', 'KEYWORD_LABELS', 'IS_UNATTRIBUTED_AD', 'KEYWORD_CLICKSERVER_URL', 'COST', 'CROSS_SELL_UNITS_SOLD', 'FLOODLIGHT_REFERRER', 'DFA_WEIGHTED_ACTIONS_CROSS_ENV', 'COST_WITH_FEED_ITEM_SHOWING', 'DEVICE_SEGMENT', 'CALL_PHONE_NUMBER', 'DFA_TRANSACTIONS_CROSS_ENV', 'PRODUCT_TARGET_CLICKSERVER_URL', 'ENGINE_REMARKETING_LIST_BID_MODIFIER', 'PRODUCT_ID', 'ADWORDS_CONVERSION_VALUE', 'KEYWORD_MAXB_ID', 'PRODUCT_BRAND', 'NEGATIVE_AD_GROUP_KEYWORD_TEXT', 'CPA_TARGET', 'SITELINK_DESCRIPTION_2', 'AD_GROUP_START_DATE', 'SITELINK_DESCRIPTION_1', 'DFA_WEIGHTED_ACTIONS', 'CALL_CALL_ONLY', 'DISPLAY_RANK_LOST_IMPRESSION_SHARE'):
                raise ValueError("each list item must be one of ('CTR', 'BING_ADS_BUDGET_TYPE', 'PRODUCT_GROUP_PARTITION_TYPE', 'NEGATIVE_CAMPAIGN_KEYWORD_TEXT', 'IMPR', 'CAMPAIGN_TYPE', 'CAMPAIGN_TARGET_ID', 'EFFECTIVE_PROVINCE_TARGETS', 'FLOODLIGHT_CONFIGURATION_ID', 'DISPLAY_BUDGET_LOST_IMPRESSION_SHARE', 'HIGH_POSITION', 'NETWORK_TARGET', 'ACCOUNT_TIMEZONE', 'LOCATION_DETAILS', 'PAID_AND_ORGANIC_CTR', 'AD_GROUP_MOBILE_BID_ADJUSTMENT', 'CONVERSION_VISIT_TIMESTAMP', 'FLOODLIGHT_EVENT_REQUEST_STRING', 'PRODUCT_GTIN', 'CAMPAIGN_LABELS', 'ADVERTISER_CONVERSION_ID', 'ADVERTISER', 'DYNAMIC_SEARCH_ADS_TARGET_CPC_BID', 'EXCLUDED_PROVINCE_TARGETS', 'ACCOUNT_CURRENCY_CODE', 'CAMPAIGN_ID', 'AD_GROUP_LABELS', 'AD', 'NEGATIVE_AD_GROUP_KEYWORD_MATCH_TYPE', 'DYNAMIC_SEARCH_ADS_TARGET_LANDING_PAGE_URL', 'LEAD_REVENUE_FROM_UNITS_SOLD', 'FLOODLIGHT_GROUP_CONVERSION_TYPE', 'PRODUCT_GROUP_ID', 'PRODUCT_AVERAGE_UNIT_PRICE', 'EFFECTIVE_PRODUCT_TARGET_MAX_CPC', 'AD_DESCRIPTION_2', 'AD_GROUP_END_DATE', 'VISIT_NETWORK_TYPE', 'LEAD_GROSS_PROFIT_FROM_UNITS_SOLD', 'AD_DESCRIPTION_1', 'DFA_ACTIONS_CROSS_ENV', 'PRODUCT_TARGET_MAX_CPC', 'AD_TYPE', 'PRODUCT_TITLE', 'METRO_TARGETS', 'KEYWORD_NEAR_MATCH_ENABLED', 'SEARCH_RANK_LOST_IMPRESSION_SHARE', 'PAID_AVG_POS', 'AD_GROUP_TABLET_BID_ADJUSTMENT', 'CROSS_SELL_AVERAGE_UNIT_PRICE', 'AD_GROUP', 'SITELINK_CLICKSERVER_URL', 'BID_STRATEGY_MAX_BID', 'PRODUCT_GROUP_MAX_BID', 'AGENCY_ID', 'CLICKS_WITH_FEED_ITEM_SHOWING', 'AD_GROUP_TARGET_ID', 'DYNAMIC_SEARCH_ADS_TARGET_CONDITIONS', 'PRODUCT_TARGET_LABELS', 'FLOODLIGHT_ORIGINAL_REVENUE', 'PRODUCT_AGE_GROUP', 'FLOODLIGHT_ORDER_ID', 'EXCLUDED_METRO_TARGETS', 'CITY_TARGETS', 'FLOODLIGHT_ACTIVITY', 'KEYWORD_LANDING_PAGE', 'PRODUCT_UNITS_SOLD', 'EXCLUDED_COUNTRY_TARGETS', 'PAID_AND_ORGANIC_CLICKS', 'AD_GROUP_ID', 'CONVERSION_ID', 'LOCATION_TARGET_BID_MODIFIER', 'CAMPAIGN_START_DATE', 'ENGINE_REMARKETING_LIST_TARGET_ALL', 'PRODUCT_CATEGORY_LEVEL_3', 'PRODUCT_CATEGORY_LEVEL_2', 'PRODUCT_CATEGORY_LEVEL_1', 'VISITS', 'MONTH_START', 'LEAD_AVERAGE_UNIT_PRICE', 'CONVERSION_SEARCH_TERM', 'CALL_IS_TRACKED', 'AVG_POS', 'CONVERSION_REVENUE', 'PRODUCT_CATEGORY_LEVEL_5', 'AD_GROUP_SEARCH_MAX_CPC', 'PRODUCT_CATEGORY_LEVEL_4', 'VISIT_REFERRER', 'DISPLAY_IMPRESSION_SHARE', 'CREATION_TIMESTAMP', 'CONVERSION_VISIT_EXTERNAL_CLICK_ID', 'SEARCH_RANK_LOST_TOP_IMPRESSION_SHARE', 'FLOODLIGHT_ACTIVITY_ID', 'ORGANIC_CLICKS', 'AD_GROUP_DESKTOP_BID_ADJUSTMENT', 'CAMPAIGN_DESKTOP_BID_ADJUSTMENT', 'CONVERSION_TIMESTAMP', 'EFFECTIVE_KEYWORD_MAX_CPC', 'NEGATIVE_CAMPAIGN_KEYWORD_MATCH_TYPE', 'PAID_COST_PER_CLICK', 'CONVERSION_QUANTITY', 'KEYWORD_MAX_CPC', 'CONVERSION_LAST_MODIFIED_TIMESTAMP', 'PRODUCT_GROUP_MAX_CPC', 'PRODUCT_TARGET_FILTER', 'ADWORDS_CONVERSIONS', 'SEARCH_BUDGET_LOST_ABSOLUTE_TOP_IMPRESSION_SHARE', 'LANGUAGE_TARGETS', 'ACCOUNT', 'ERS_TARGET', 'LOCATION_TARGET_NAME', 'AGE_TARGET_AGE_RANGE', 'LOCATION_CATEGORY', 'COUNTRY_TARGETS', 'DFA_REVENUE', 'PRODUCT_LANDING_PAGE_URL', 'PRODUCT_GROUP', 'PRODUCT_GROUP_CLICKSERVER_URL', 'ABSOLUTE_TOP_IMPRESSION_PERCENTAGE', 'ENGINE_STATUS', 'AD_GROUP_EXACT_MAX_CPC', 'LOCATION_BUSINESS_NAME', 'PRODUCT_TARGET_MAX_BID', 'NEGATIVE_CAMPAIGN_KEYWORD_ID', 'ADVERTISER_ID', 'AGE_TARGET_BID_MODIFIER', 'KEYWORD_URL_PARAMS', 'NEGATIVE_CAMPAIGN_TARGET_ID', 'PRODUCT_STORE_ID', 'LEAD_UNITS_SOLD', 'EFFECTIVE_METRO_TARGETS', 'EXCLUDED_CITY_TARGETS', 'PRODUCT_GENDER', 'CONVERSION_DATE', 'KEYWORD_MIN_BID', 'PRODUCT_TYPE_LEVEL_1', 'PRODUCT_TARGET_LANDING_PAGE', 'KEYWORD_TEXT', 'PRODUCT_TYPE_LEVEL_2', 'ACCOUNT_TYPE', 'PRODUCT_TYPE_LEVEL_3', 'YAHOO_JAPAN_BID_STRATEGY', 'PRODUCT_TYPE_LEVEL_4', 'PRODUCT_TYPE_LEVEL_5', 'CALL_CONVERSION_TRACKER_ID', 'AD_GROUP_TYPE', 'VISIT_DATE', 'DFA_ACTIONS', 'EFFECTIVE_PRODUCT_GROUP_MAX_CPC', 'DFA_TRANSACTIONS', 'KEYWORD_MATCH_TYPE', 'FLOODLIGHT_ACTIVITY_TARGET_IDS', 'LEAD_GROSS_PROFIT_MARGIN', 'FEED_TYPE', 'FLOODLIGHT_OPTIMIZATION_ENABLED', 'SEARCH_IMPRESSION_SHARE', 'DAILY_BUDGET', 'AD_GROUP_CONTENT_MAX_CPC', 'PRODUCT_MPN', 'ADVERTISER_CURRENCY_CODE', 'ADWORDS_BID_STRATEGY', 'AGENCY', 'PRODUCT_CONDITION', 'SITELINK_DISPLAY_TEXT', 'PRODUCT_TARGET_ENGINE_ID', 'ORGANIC_QUERIES', 'EFFECTIVE_LABELS', 'SEARCH_ABSOLUTE_TOP_IMPRESSION_SHARE', 'LOCATION_FILTER', 'SEARCH_TOP_IMPRESSION_SHARE', 'AD_ID', 'AD_GROUP_ENGINE_ID', 'BID_STRATEGY_MIN_BID', 'PRODUCT_PATTERN', 'AD_LANDING_PAGE', 'AD_GROUP_BROAD_MAX_CPC', 'VISIT_SEARCH_QUERY', 'PAID_IMPRESSIONS', 'FLOODLIGHT_ACTIVITY_TAG', 'CAMPAIGN_STATUS', 'AD_GROUP_PHRASE_MAX_CPC', 'TOP_OF_PAGE_BID_AVG', 'CALL_COUNTRY_CODE', 'CROSS_SELL_GROSS_FROM_UNITS_SOLD', 'PRODUCT_CUSTOM_LABEL_0', 'PRODUCT_CUSTOM_LABEL_1', 'PRODUCT_CUSTOM_LABEL_2', 'PRODUCT_CUSTOM_LABEL_3', 'DYNAMIC_SEARCH_ADS_TARGET_COVERAGE', 'PRODUCT_CUSTOM_LABEL_4', 'AD_ENGINE_ID', 'SEARCH_BUDGET_LOST_IMPRESSION_SHARE', 'DFA_NETWORK_TIMEZONE', 'PRODUCT_LANGUAGE', 'AVG_CPC', 'CAMPAIGN_END_DATE', 'PRODUCT_COST_OF_GOODS_SOLD', 'VISIT_TIMESTAMP', 'ORGANIC_AVG_POS', 'EFFECTIVE_CITY_TARGETS', 'GENDER_TARGET_BID_MODIFIER', 'TOP_OF_PAGE_BID_CURRENT', 'PRODUCT_SIZE', 'AD_ROTATION', 'PROVINCE_TARGETS', 'PRODUCT_TARGET_ID', 'INVENTORY_ACCOUNT_ID', 'BING_ADS_LANGUAGE', 'UNCLASSIFIED_TARGET_TYPE', 'DFA_NETWORK_ID', 'QUALITY_SCORE_AVG', 'FLOODLIGHT_GROUP_TAG', 'LAST_MODIFIED_TIMESTAMP', 'LOW_POSITION', 'AD_GROUP_STATUS', 'BID_STRATEGY_ID', 'BING_KEYWORD_PARAM_2', 'AVG_CPM', 'PAID_CLICKS', 'CROSS_SELL_COST_OF_GOODS_SOLD', 'PRODUCT_CHANNEL_EXCLUSIVITY', 'FLOODLIGHT_GROUP_ID', 'BING_KEYWORD_PARAM_3', 'NEGATIVE_AD_GROUP_KEYWORD_ID', 'PAID_CTR', 'PRODUCT_ITEM_GROUP_ID', 'PRODUCT_GROUP_MIN_BID', 'DFA_ADVERTISER_ID', 'CAMPAIGN_ENGINE_ID', 'GOOGLE_ANALYTICS_TIMEZONE', 'PRODUCT_CHANNEL', 'CLICKS', 'SEARCH_BUDGET_LOST_TOP_IMPRESSION_SHARE', 'PRODUCT_COUNTRY', 'ENGINE_REMARKETING_LIST', 'CONVERSION_TYPE', 'NEGATIVE_AD_GROUP_TARGET_ID', 'EFFECTIVE_DEVICE_TARGETS', 'EFFECTIVE_COUNTRY_TARGETS', 'AD_HEADLINE', 'ORGANIC_CTR', 'CAMPAIGN', 'CALL_CONVERSION_TRACKER', 'VISIT_EXTERNAL_CLICK_ID', 'APP_ID', 'SEARCH_QUERY', 'ROAS_TARGET', 'IS_DISPLAY_KEYWORD', 'PRODUCT_AVAILABILITY', 'PRODUCT_PRICE', 'PRODUCT_CATEGORY', 'ACCOUNT_ENGINE_ID', 'CROSS_SELL_REVENUE_FROM_UNITS_SOLD', 'PRODUCT_MATERIAL', 'LEAD_COST_OF_GOODS_SOLD', 'PRODUCT_SALE_PRICE', 'ACCOUNT_ID', 'APP_STORE', 'EFFECTIVE_BID_STRATEGY', 'FEED_ITEM_ID', 'BING_ADS_AD_DISTRIBUTIONS', 'DEVICE_TARGETS', 'QUALITY_SCORE_CURRENT', 'SERP_TYPE', 'CAMPAIGN_MOBILE_BID_ADJUSTMENT', 'STATUS', 'TOP_IMPRESSION_PERCENTAGE', 'AD_LABELS', 'MONTHLY_SPEND_TARGET', 'CROSS_SELL_GROSS_PROFIT_MARGIN', 'CONVERSION_VISIT_ID', 'BID_STRATEGY_GOAL', 'PRODUCT_GROUP_LANDING_PAGE', 'ADWORDS_VIEW_THROUGH_CONVERSIONS', 'CONVERSION_ATTRIBUTION_TYPE', 'EFFECTIVE_BID_STRATEGY_ID', 'CAMPAIGN_TABLET_BID_ADJUSTMENT', 'PRODUCT_REVENUE_FROM_UNITS_SOLD', 'YAHOO_GEO_TARGETS', 'PAID_AND_ORGANIC_QUERIES', 'DFA_REVENUE_CROSS_ENV', 'PRODUCT_TARGET_MIN_BID', 'DATE', 'BID_STRATEGY', 'VISIT_ID', 'DELIVERY_METHOD', 'AD_DISPLAY_URL', 'SEARCH_RANK_LOST_ABSOLUTE_TOP_IMPRESSION_SHARE', 'MONTHLY_BUDGET', 'AD_HEADLINE_2', 'BID_STRATEGY_INHERITED', 'KEYWORD_ENGINE_ID', 'SITELINK_LANDING_PAGE_URL', 'AD_HEADLINE_3', 'AD_PATH_FIELD_2', 'KEYWORD_ID', 'AD_PATH_FIELD_1', 'PRODUCT_COLOR', 'UNCLASSIFIED_TARGET_NAME', 'FEED_ID', 'AD_PROMOTION_LINE', 'FLOODLIGHT_GROUP', 'GENDER_TARGET_GENDER_TYPE', 'KEYWORD_LABELS', 'IS_UNATTRIBUTED_AD', 'KEYWORD_CLICKSERVER_URL', 'COST', 'CROSS_SELL_UNITS_SOLD', 'FLOODLIGHT_REFERRER', 'DFA_WEIGHTED_ACTIONS_CROSS_ENV', 'COST_WITH_FEED_ITEM_SHOWING', 'DEVICE_SEGMENT', 'CALL_PHONE_NUMBER', 'DFA_TRANSACTIONS_CROSS_ENV', 'PRODUCT_TARGET_CLICKSERVER_URL', 'ENGINE_REMARKETING_LIST_BID_MODIFIER', 'PRODUCT_ID', 'ADWORDS_CONVERSION_VALUE', 'KEYWORD_MAXB_ID', 'PRODUCT_BRAND', 'NEGATIVE_AD_GROUP_KEYWORD_TEXT', 'CPA_TARGET', 'SITELINK_DESCRIPTION_2', 'AD_GROUP_START_DATE', 'SITELINK_DESCRIPTION_1', 'DFA_WEIGHTED_ACTIONS', 'CALL_CALL_ONLY', 'DISPLAY_RANK_LOST_IMPRESSION_SHARE')")
        return value

    @field_validator('metrics')
    def metrics_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        for i in value:
            if i not in ('CTR', 'BING_ADS_BUDGET_TYPE', 'PRODUCT_GROUP_PARTITION_TYPE', 'NEGATIVE_CAMPAIGN_KEYWORD_TEXT', 'IMPR', 'CAMPAIGN_TYPE', 'CAMPAIGN_TARGET_ID', 'EFFECTIVE_PROVINCE_TARGETS', 'FLOODLIGHT_CONFIGURATION_ID', 'DISPLAY_BUDGET_LOST_IMPRESSION_SHARE', 'HIGH_POSITION', 'NETWORK_TARGET', 'ACCOUNT_TIMEZONE', 'LOCATION_DETAILS', 'PAID_AND_ORGANIC_CTR', 'AD_GROUP_MOBILE_BID_ADJUSTMENT', 'CONVERSION_VISIT_TIMESTAMP', 'FLOODLIGHT_EVENT_REQUEST_STRING', 'PRODUCT_GTIN', 'CAMPAIGN_LABELS', 'ADVERTISER_CONVERSION_ID', 'ADVERTISER', 'DYNAMIC_SEARCH_ADS_TARGET_CPC_BID', 'EXCLUDED_PROVINCE_TARGETS', 'ACCOUNT_CURRENCY_CODE', 'CAMPAIGN_ID', 'AD_GROUP_LABELS', 'AD', 'NEGATIVE_AD_GROUP_KEYWORD_MATCH_TYPE', 'DYNAMIC_SEARCH_ADS_TARGET_LANDING_PAGE_URL', 'LEAD_REVENUE_FROM_UNITS_SOLD', 'FLOODLIGHT_GROUP_CONVERSION_TYPE', 'PRODUCT_GROUP_ID', 'PRODUCT_AVERAGE_UNIT_PRICE', 'EFFECTIVE_PRODUCT_TARGET_MAX_CPC', 'AD_DESCRIPTION_2', 'AD_GROUP_END_DATE', 'VISIT_NETWORK_TYPE', 'LEAD_GROSS_PROFIT_FROM_UNITS_SOLD', 'AD_DESCRIPTION_1', 'DFA_ACTIONS_CROSS_ENV', 'PRODUCT_TARGET_MAX_CPC', 'AD_TYPE', 'PRODUCT_TITLE', 'METRO_TARGETS', 'KEYWORD_NEAR_MATCH_ENABLED', 'SEARCH_RANK_LOST_IMPRESSION_SHARE', 'PAID_AVG_POS', 'AD_GROUP_TABLET_BID_ADJUSTMENT', 'CROSS_SELL_AVERAGE_UNIT_PRICE', 'AD_GROUP', 'SITELINK_CLICKSERVER_URL', 'BID_STRATEGY_MAX_BID', 'PRODUCT_GROUP_MAX_BID', 'AGENCY_ID', 'CLICKS_WITH_FEED_ITEM_SHOWING', 'AD_GROUP_TARGET_ID', 'DYNAMIC_SEARCH_ADS_TARGET_CONDITIONS', 'PRODUCT_TARGET_LABELS', 'FLOODLIGHT_ORIGINAL_REVENUE', 'PRODUCT_AGE_GROUP', 'FLOODLIGHT_ORDER_ID', 'EXCLUDED_METRO_TARGETS', 'CITY_TARGETS', 'FLOODLIGHT_ACTIVITY', 'KEYWORD_LANDING_PAGE', 'PRODUCT_UNITS_SOLD', 'EXCLUDED_COUNTRY_TARGETS', 'PAID_AND_ORGANIC_CLICKS', 'AD_GROUP_ID', 'CONVERSION_ID', 'LOCATION_TARGET_BID_MODIFIER', 'CAMPAIGN_START_DATE', 'ENGINE_REMARKETING_LIST_TARGET_ALL', 'PRODUCT_CATEGORY_LEVEL_3', 'PRODUCT_CATEGORY_LEVEL_2', 'PRODUCT_CATEGORY_LEVEL_1', 'VISITS', 'MONTH_START', 'LEAD_AVERAGE_UNIT_PRICE', 'CONVERSION_SEARCH_TERM', 'CALL_IS_TRACKED', 'AVG_POS', 'CONVERSION_REVENUE', 'PRODUCT_CATEGORY_LEVEL_5', 'AD_GROUP_SEARCH_MAX_CPC', 'PRODUCT_CATEGORY_LEVEL_4', 'VISIT_REFERRER', 'DISPLAY_IMPRESSION_SHARE', 'CREATION_TIMESTAMP', 'CONVERSION_VISIT_EXTERNAL_CLICK_ID', 'SEARCH_RANK_LOST_TOP_IMPRESSION_SHARE', 'FLOODLIGHT_ACTIVITY_ID', 'ORGANIC_CLICKS', 'AD_GROUP_DESKTOP_BID_ADJUSTMENT', 'CAMPAIGN_DESKTOP_BID_ADJUSTMENT', 'CONVERSION_TIMESTAMP', 'EFFECTIVE_KEYWORD_MAX_CPC', 'NEGATIVE_CAMPAIGN_KEYWORD_MATCH_TYPE', 'PAID_COST_PER_CLICK', 'CONVERSION_QUANTITY', 'KEYWORD_MAX_CPC', 'CONVERSION_LAST_MODIFIED_TIMESTAMP', 'PRODUCT_GROUP_MAX_CPC', 'PRODUCT_TARGET_FILTER', 'ADWORDS_CONVERSIONS', 'SEARCH_BUDGET_LOST_ABSOLUTE_TOP_IMPRESSION_SHARE', 'LANGUAGE_TARGETS', 'ACCOUNT', 'ERS_TARGET', 'LOCATION_TARGET_NAME', 'AGE_TARGET_AGE_RANGE', 'LOCATION_CATEGORY', 'COUNTRY_TARGETS', 'DFA_REVENUE', 'PRODUCT_LANDING_PAGE_URL', 'PRODUCT_GROUP', 'PRODUCT_GROUP_CLICKSERVER_URL', 'ABSOLUTE_TOP_IMPRESSION_PERCENTAGE', 'ENGINE_STATUS', 'AD_GROUP_EXACT_MAX_CPC', 'LOCATION_BUSINESS_NAME', 'PRODUCT_TARGET_MAX_BID', 'NEGATIVE_CAMPAIGN_KEYWORD_ID', 'ADVERTISER_ID', 'AGE_TARGET_BID_MODIFIER', 'KEYWORD_URL_PARAMS', 'NEGATIVE_CAMPAIGN_TARGET_ID', 'PRODUCT_STORE_ID', 'LEAD_UNITS_SOLD', 'EFFECTIVE_METRO_TARGETS', 'EXCLUDED_CITY_TARGETS', 'PRODUCT_GENDER', 'CONVERSION_DATE', 'KEYWORD_MIN_BID', 'PRODUCT_TYPE_LEVEL_1', 'PRODUCT_TARGET_LANDING_PAGE', 'KEYWORD_TEXT', 'PRODUCT_TYPE_LEVEL_2', 'ACCOUNT_TYPE', 'PRODUCT_TYPE_LEVEL_3', 'YAHOO_JAPAN_BID_STRATEGY', 'PRODUCT_TYPE_LEVEL_4', 'PRODUCT_TYPE_LEVEL_5', 'CALL_CONVERSION_TRACKER_ID', 'AD_GROUP_TYPE', 'VISIT_DATE', 'DFA_ACTIONS', 'EFFECTIVE_PRODUCT_GROUP_MAX_CPC', 'DFA_TRANSACTIONS', 'KEYWORD_MATCH_TYPE', 'FLOODLIGHT_ACTIVITY_TARGET_IDS', 'LEAD_GROSS_PROFIT_MARGIN', 'FEED_TYPE', 'FLOODLIGHT_OPTIMIZATION_ENABLED', 'SEARCH_IMPRESSION_SHARE', 'DAILY_BUDGET', 'AD_GROUP_CONTENT_MAX_CPC', 'PRODUCT_MPN', 'ADVERTISER_CURRENCY_CODE', 'ADWORDS_BID_STRATEGY', 'AGENCY', 'PRODUCT_CONDITION', 'SITELINK_DISPLAY_TEXT', 'PRODUCT_TARGET_ENGINE_ID', 'ORGANIC_QUERIES', 'EFFECTIVE_LABELS', 'SEARCH_ABSOLUTE_TOP_IMPRESSION_SHARE', 'LOCATION_FILTER', 'SEARCH_TOP_IMPRESSION_SHARE', 'AD_ID', 'AD_GROUP_ENGINE_ID', 'BID_STRATEGY_MIN_BID', 'PRODUCT_PATTERN', 'AD_LANDING_PAGE', 'AD_GROUP_BROAD_MAX_CPC', 'VISIT_SEARCH_QUERY', 'PAID_IMPRESSIONS', 'FLOODLIGHT_ACTIVITY_TAG', 'CAMPAIGN_STATUS', 'AD_GROUP_PHRASE_MAX_CPC', 'TOP_OF_PAGE_BID_AVG', 'CALL_COUNTRY_CODE', 'CROSS_SELL_GROSS_FROM_UNITS_SOLD', 'PRODUCT_CUSTOM_LABEL_0', 'PRODUCT_CUSTOM_LABEL_1', 'PRODUCT_CUSTOM_LABEL_2', 'PRODUCT_CUSTOM_LABEL_3', 'DYNAMIC_SEARCH_ADS_TARGET_COVERAGE', 'PRODUCT_CUSTOM_LABEL_4', 'AD_ENGINE_ID', 'SEARCH_BUDGET_LOST_IMPRESSION_SHARE', 'DFA_NETWORK_TIMEZONE', 'PRODUCT_LANGUAGE', 'AVG_CPC', 'CAMPAIGN_END_DATE', 'PRODUCT_COST_OF_GOODS_SOLD', 'VISIT_TIMESTAMP', 'ORGANIC_AVG_POS', 'EFFECTIVE_CITY_TARGETS', 'GENDER_TARGET_BID_MODIFIER', 'TOP_OF_PAGE_BID_CURRENT', 'PRODUCT_SIZE', 'AD_ROTATION', 'PROVINCE_TARGETS', 'PRODUCT_TARGET_ID', 'INVENTORY_ACCOUNT_ID', 'BING_ADS_LANGUAGE', 'UNCLASSIFIED_TARGET_TYPE', 'DFA_NETWORK_ID', 'QUALITY_SCORE_AVG', 'FLOODLIGHT_GROUP_TAG', 'LAST_MODIFIED_TIMESTAMP', 'LOW_POSITION', 'AD_GROUP_STATUS', 'BID_STRATEGY_ID', 'BING_KEYWORD_PARAM_2', 'AVG_CPM', 'PAID_CLICKS', 'CROSS_SELL_COST_OF_GOODS_SOLD', 'PRODUCT_CHANNEL_EXCLUSIVITY', 'FLOODLIGHT_GROUP_ID', 'BING_KEYWORD_PARAM_3', 'NEGATIVE_AD_GROUP_KEYWORD_ID', 'PAID_CTR', 'PRODUCT_ITEM_GROUP_ID', 'PRODUCT_GROUP_MIN_BID', 'DFA_ADVERTISER_ID', 'CAMPAIGN_ENGINE_ID', 'GOOGLE_ANALYTICS_TIMEZONE', 'PRODUCT_CHANNEL', 'CLICKS', 'SEARCH_BUDGET_LOST_TOP_IMPRESSION_SHARE', 'PRODUCT_COUNTRY', 'ENGINE_REMARKETING_LIST', 'CONVERSION_TYPE', 'NEGATIVE_AD_GROUP_TARGET_ID', 'EFFECTIVE_DEVICE_TARGETS', 'EFFECTIVE_COUNTRY_TARGETS', 'AD_HEADLINE', 'ORGANIC_CTR', 'CAMPAIGN', 'CALL_CONVERSION_TRACKER', 'VISIT_EXTERNAL_CLICK_ID', 'APP_ID', 'SEARCH_QUERY', 'ROAS_TARGET', 'IS_DISPLAY_KEYWORD', 'PRODUCT_AVAILABILITY', 'PRODUCT_PRICE', 'PRODUCT_CATEGORY', 'ACCOUNT_ENGINE_ID', 'CROSS_SELL_REVENUE_FROM_UNITS_SOLD', 'PRODUCT_MATERIAL', 'LEAD_COST_OF_GOODS_SOLD', 'PRODUCT_SALE_PRICE', 'ACCOUNT_ID', 'APP_STORE', 'EFFECTIVE_BID_STRATEGY', 'FEED_ITEM_ID', 'BING_ADS_AD_DISTRIBUTIONS', 'DEVICE_TARGETS', 'QUALITY_SCORE_CURRENT', 'SERP_TYPE', 'CAMPAIGN_MOBILE_BID_ADJUSTMENT', 'STATUS', 'TOP_IMPRESSION_PERCENTAGE', 'AD_LABELS', 'MONTHLY_SPEND_TARGET', 'CROSS_SELL_GROSS_PROFIT_MARGIN', 'CONVERSION_VISIT_ID', 'BID_STRATEGY_GOAL', 'PRODUCT_GROUP_LANDING_PAGE', 'ADWORDS_VIEW_THROUGH_CONVERSIONS', 'CONVERSION_ATTRIBUTION_TYPE', 'EFFECTIVE_BID_STRATEGY_ID', 'CAMPAIGN_TABLET_BID_ADJUSTMENT', 'PRODUCT_REVENUE_FROM_UNITS_SOLD', 'YAHOO_GEO_TARGETS', 'PAID_AND_ORGANIC_QUERIES', 'DFA_REVENUE_CROSS_ENV', 'PRODUCT_TARGET_MIN_BID', 'DATE', 'BID_STRATEGY', 'VISIT_ID', 'DELIVERY_METHOD', 'AD_DISPLAY_URL', 'SEARCH_RANK_LOST_ABSOLUTE_TOP_IMPRESSION_SHARE', 'MONTHLY_BUDGET', 'AD_HEADLINE_2', 'BID_STRATEGY_INHERITED', 'KEYWORD_ENGINE_ID', 'SITELINK_LANDING_PAGE_URL', 'AD_HEADLINE_3', 'AD_PATH_FIELD_2', 'KEYWORD_ID', 'AD_PATH_FIELD_1', 'PRODUCT_COLOR', 'UNCLASSIFIED_TARGET_NAME', 'FEED_ID', 'AD_PROMOTION_LINE', 'FLOODLIGHT_GROUP', 'GENDER_TARGET_GENDER_TYPE', 'KEYWORD_LABELS', 'IS_UNATTRIBUTED_AD', 'KEYWORD_CLICKSERVER_URL', 'COST', 'CROSS_SELL_UNITS_SOLD', 'FLOODLIGHT_REFERRER', 'DFA_WEIGHTED_ACTIONS_CROSS_ENV', 'COST_WITH_FEED_ITEM_SHOWING', 'DEVICE_SEGMENT', 'CALL_PHONE_NUMBER', 'DFA_TRANSACTIONS_CROSS_ENV', 'PRODUCT_TARGET_CLICKSERVER_URL', 'ENGINE_REMARKETING_LIST_BID_MODIFIER', 'PRODUCT_ID', 'ADWORDS_CONVERSION_VALUE', 'KEYWORD_MAXB_ID', 'PRODUCT_BRAND', 'NEGATIVE_AD_GROUP_KEYWORD_TEXT', 'CPA_TARGET', 'SITELINK_DESCRIPTION_2', 'AD_GROUP_START_DATE', 'SITELINK_DESCRIPTION_1', 'DFA_WEIGHTED_ACTIONS', 'CALL_CALL_ONLY', 'DISPLAY_RANK_LOST_IMPRESSION_SHARE'):
                raise ValueError("each list item must be one of ('CTR', 'BING_ADS_BUDGET_TYPE', 'PRODUCT_GROUP_PARTITION_TYPE', 'NEGATIVE_CAMPAIGN_KEYWORD_TEXT', 'IMPR', 'CAMPAIGN_TYPE', 'CAMPAIGN_TARGET_ID', 'EFFECTIVE_PROVINCE_TARGETS', 'FLOODLIGHT_CONFIGURATION_ID', 'DISPLAY_BUDGET_LOST_IMPRESSION_SHARE', 'HIGH_POSITION', 'NETWORK_TARGET', 'ACCOUNT_TIMEZONE', 'LOCATION_DETAILS', 'PAID_AND_ORGANIC_CTR', 'AD_GROUP_MOBILE_BID_ADJUSTMENT', 'CONVERSION_VISIT_TIMESTAMP', 'FLOODLIGHT_EVENT_REQUEST_STRING', 'PRODUCT_GTIN', 'CAMPAIGN_LABELS', 'ADVERTISER_CONVERSION_ID', 'ADVERTISER', 'DYNAMIC_SEARCH_ADS_TARGET_CPC_BID', 'EXCLUDED_PROVINCE_TARGETS', 'ACCOUNT_CURRENCY_CODE', 'CAMPAIGN_ID', 'AD_GROUP_LABELS', 'AD', 'NEGATIVE_AD_GROUP_KEYWORD_MATCH_TYPE', 'DYNAMIC_SEARCH_ADS_TARGET_LANDING_PAGE_URL', 'LEAD_REVENUE_FROM_UNITS_SOLD', 'FLOODLIGHT_GROUP_CONVERSION_TYPE', 'PRODUCT_GROUP_ID', 'PRODUCT_AVERAGE_UNIT_PRICE', 'EFFECTIVE_PRODUCT_TARGET_MAX_CPC', 'AD_DESCRIPTION_2', 'AD_GROUP_END_DATE', 'VISIT_NETWORK_TYPE', 'LEAD_GROSS_PROFIT_FROM_UNITS_SOLD', 'AD_DESCRIPTION_1', 'DFA_ACTIONS_CROSS_ENV', 'PRODUCT_TARGET_MAX_CPC', 'AD_TYPE', 'PRODUCT_TITLE', 'METRO_TARGETS', 'KEYWORD_NEAR_MATCH_ENABLED', 'SEARCH_RANK_LOST_IMPRESSION_SHARE', 'PAID_AVG_POS', 'AD_GROUP_TABLET_BID_ADJUSTMENT', 'CROSS_SELL_AVERAGE_UNIT_PRICE', 'AD_GROUP', 'SITELINK_CLICKSERVER_URL', 'BID_STRATEGY_MAX_BID', 'PRODUCT_GROUP_MAX_BID', 'AGENCY_ID', 'CLICKS_WITH_FEED_ITEM_SHOWING', 'AD_GROUP_TARGET_ID', 'DYNAMIC_SEARCH_ADS_TARGET_CONDITIONS', 'PRODUCT_TARGET_LABELS', 'FLOODLIGHT_ORIGINAL_REVENUE', 'PRODUCT_AGE_GROUP', 'FLOODLIGHT_ORDER_ID', 'EXCLUDED_METRO_TARGETS', 'CITY_TARGETS', 'FLOODLIGHT_ACTIVITY', 'KEYWORD_LANDING_PAGE', 'PRODUCT_UNITS_SOLD', 'EXCLUDED_COUNTRY_TARGETS', 'PAID_AND_ORGANIC_CLICKS', 'AD_GROUP_ID', 'CONVERSION_ID', 'LOCATION_TARGET_BID_MODIFIER', 'CAMPAIGN_START_DATE', 'ENGINE_REMARKETING_LIST_TARGET_ALL', 'PRODUCT_CATEGORY_LEVEL_3', 'PRODUCT_CATEGORY_LEVEL_2', 'PRODUCT_CATEGORY_LEVEL_1', 'VISITS', 'MONTH_START', 'LEAD_AVERAGE_UNIT_PRICE', 'CONVERSION_SEARCH_TERM', 'CALL_IS_TRACKED', 'AVG_POS', 'CONVERSION_REVENUE', 'PRODUCT_CATEGORY_LEVEL_5', 'AD_GROUP_SEARCH_MAX_CPC', 'PRODUCT_CATEGORY_LEVEL_4', 'VISIT_REFERRER', 'DISPLAY_IMPRESSION_SHARE', 'CREATION_TIMESTAMP', 'CONVERSION_VISIT_EXTERNAL_CLICK_ID', 'SEARCH_RANK_LOST_TOP_IMPRESSION_SHARE', 'FLOODLIGHT_ACTIVITY_ID', 'ORGANIC_CLICKS', 'AD_GROUP_DESKTOP_BID_ADJUSTMENT', 'CAMPAIGN_DESKTOP_BID_ADJUSTMENT', 'CONVERSION_TIMESTAMP', 'EFFECTIVE_KEYWORD_MAX_CPC', 'NEGATIVE_CAMPAIGN_KEYWORD_MATCH_TYPE', 'PAID_COST_PER_CLICK', 'CONVERSION_QUANTITY', 'KEYWORD_MAX_CPC', 'CONVERSION_LAST_MODIFIED_TIMESTAMP', 'PRODUCT_GROUP_MAX_CPC', 'PRODUCT_TARGET_FILTER', 'ADWORDS_CONVERSIONS', 'SEARCH_BUDGET_LOST_ABSOLUTE_TOP_IMPRESSION_SHARE', 'LANGUAGE_TARGETS', 'ACCOUNT', 'ERS_TARGET', 'LOCATION_TARGET_NAME', 'AGE_TARGET_AGE_RANGE', 'LOCATION_CATEGORY', 'COUNTRY_TARGETS', 'DFA_REVENUE', 'PRODUCT_LANDING_PAGE_URL', 'PRODUCT_GROUP', 'PRODUCT_GROUP_CLICKSERVER_URL', 'ABSOLUTE_TOP_IMPRESSION_PERCENTAGE', 'ENGINE_STATUS', 'AD_GROUP_EXACT_MAX_CPC', 'LOCATION_BUSINESS_NAME', 'PRODUCT_TARGET_MAX_BID', 'NEGATIVE_CAMPAIGN_KEYWORD_ID', 'ADVERTISER_ID', 'AGE_TARGET_BID_MODIFIER', 'KEYWORD_URL_PARAMS', 'NEGATIVE_CAMPAIGN_TARGET_ID', 'PRODUCT_STORE_ID', 'LEAD_UNITS_SOLD', 'EFFECTIVE_METRO_TARGETS', 'EXCLUDED_CITY_TARGETS', 'PRODUCT_GENDER', 'CONVERSION_DATE', 'KEYWORD_MIN_BID', 'PRODUCT_TYPE_LEVEL_1', 'PRODUCT_TARGET_LANDING_PAGE', 'KEYWORD_TEXT', 'PRODUCT_TYPE_LEVEL_2', 'ACCOUNT_TYPE', 'PRODUCT_TYPE_LEVEL_3', 'YAHOO_JAPAN_BID_STRATEGY', 'PRODUCT_TYPE_LEVEL_4', 'PRODUCT_TYPE_LEVEL_5', 'CALL_CONVERSION_TRACKER_ID', 'AD_GROUP_TYPE', 'VISIT_DATE', 'DFA_ACTIONS', 'EFFECTIVE_PRODUCT_GROUP_MAX_CPC', 'DFA_TRANSACTIONS', 'KEYWORD_MATCH_TYPE', 'FLOODLIGHT_ACTIVITY_TARGET_IDS', 'LEAD_GROSS_PROFIT_MARGIN', 'FEED_TYPE', 'FLOODLIGHT_OPTIMIZATION_ENABLED', 'SEARCH_IMPRESSION_SHARE', 'DAILY_BUDGET', 'AD_GROUP_CONTENT_MAX_CPC', 'PRODUCT_MPN', 'ADVERTISER_CURRENCY_CODE', 'ADWORDS_BID_STRATEGY', 'AGENCY', 'PRODUCT_CONDITION', 'SITELINK_DISPLAY_TEXT', 'PRODUCT_TARGET_ENGINE_ID', 'ORGANIC_QUERIES', 'EFFECTIVE_LABELS', 'SEARCH_ABSOLUTE_TOP_IMPRESSION_SHARE', 'LOCATION_FILTER', 'SEARCH_TOP_IMPRESSION_SHARE', 'AD_ID', 'AD_GROUP_ENGINE_ID', 'BID_STRATEGY_MIN_BID', 'PRODUCT_PATTERN', 'AD_LANDING_PAGE', 'AD_GROUP_BROAD_MAX_CPC', 'VISIT_SEARCH_QUERY', 'PAID_IMPRESSIONS', 'FLOODLIGHT_ACTIVITY_TAG', 'CAMPAIGN_STATUS', 'AD_GROUP_PHRASE_MAX_CPC', 'TOP_OF_PAGE_BID_AVG', 'CALL_COUNTRY_CODE', 'CROSS_SELL_GROSS_FROM_UNITS_SOLD', 'PRODUCT_CUSTOM_LABEL_0', 'PRODUCT_CUSTOM_LABEL_1', 'PRODUCT_CUSTOM_LABEL_2', 'PRODUCT_CUSTOM_LABEL_3', 'DYNAMIC_SEARCH_ADS_TARGET_COVERAGE', 'PRODUCT_CUSTOM_LABEL_4', 'AD_ENGINE_ID', 'SEARCH_BUDGET_LOST_IMPRESSION_SHARE', 'DFA_NETWORK_TIMEZONE', 'PRODUCT_LANGUAGE', 'AVG_CPC', 'CAMPAIGN_END_DATE', 'PRODUCT_COST_OF_GOODS_SOLD', 'VISIT_TIMESTAMP', 'ORGANIC_AVG_POS', 'EFFECTIVE_CITY_TARGETS', 'GENDER_TARGET_BID_MODIFIER', 'TOP_OF_PAGE_BID_CURRENT', 'PRODUCT_SIZE', 'AD_ROTATION', 'PROVINCE_TARGETS', 'PRODUCT_TARGET_ID', 'INVENTORY_ACCOUNT_ID', 'BING_ADS_LANGUAGE', 'UNCLASSIFIED_TARGET_TYPE', 'DFA_NETWORK_ID', 'QUALITY_SCORE_AVG', 'FLOODLIGHT_GROUP_TAG', 'LAST_MODIFIED_TIMESTAMP', 'LOW_POSITION', 'AD_GROUP_STATUS', 'BID_STRATEGY_ID', 'BING_KEYWORD_PARAM_2', 'AVG_CPM', 'PAID_CLICKS', 'CROSS_SELL_COST_OF_GOODS_SOLD', 'PRODUCT_CHANNEL_EXCLUSIVITY', 'FLOODLIGHT_GROUP_ID', 'BING_KEYWORD_PARAM_3', 'NEGATIVE_AD_GROUP_KEYWORD_ID', 'PAID_CTR', 'PRODUCT_ITEM_GROUP_ID', 'PRODUCT_GROUP_MIN_BID', 'DFA_ADVERTISER_ID', 'CAMPAIGN_ENGINE_ID', 'GOOGLE_ANALYTICS_TIMEZONE', 'PRODUCT_CHANNEL', 'CLICKS', 'SEARCH_BUDGET_LOST_TOP_IMPRESSION_SHARE', 'PRODUCT_COUNTRY', 'ENGINE_REMARKETING_LIST', 'CONVERSION_TYPE', 'NEGATIVE_AD_GROUP_TARGET_ID', 'EFFECTIVE_DEVICE_TARGETS', 'EFFECTIVE_COUNTRY_TARGETS', 'AD_HEADLINE', 'ORGANIC_CTR', 'CAMPAIGN', 'CALL_CONVERSION_TRACKER', 'VISIT_EXTERNAL_CLICK_ID', 'APP_ID', 'SEARCH_QUERY', 'ROAS_TARGET', 'IS_DISPLAY_KEYWORD', 'PRODUCT_AVAILABILITY', 'PRODUCT_PRICE', 'PRODUCT_CATEGORY', 'ACCOUNT_ENGINE_ID', 'CROSS_SELL_REVENUE_FROM_UNITS_SOLD', 'PRODUCT_MATERIAL', 'LEAD_COST_OF_GOODS_SOLD', 'PRODUCT_SALE_PRICE', 'ACCOUNT_ID', 'APP_STORE', 'EFFECTIVE_BID_STRATEGY', 'FEED_ITEM_ID', 'BING_ADS_AD_DISTRIBUTIONS', 'DEVICE_TARGETS', 'QUALITY_SCORE_CURRENT', 'SERP_TYPE', 'CAMPAIGN_MOBILE_BID_ADJUSTMENT', 'STATUS', 'TOP_IMPRESSION_PERCENTAGE', 'AD_LABELS', 'MONTHLY_SPEND_TARGET', 'CROSS_SELL_GROSS_PROFIT_MARGIN', 'CONVERSION_VISIT_ID', 'BID_STRATEGY_GOAL', 'PRODUCT_GROUP_LANDING_PAGE', 'ADWORDS_VIEW_THROUGH_CONVERSIONS', 'CONVERSION_ATTRIBUTION_TYPE', 'EFFECTIVE_BID_STRATEGY_ID', 'CAMPAIGN_TABLET_BID_ADJUSTMENT', 'PRODUCT_REVENUE_FROM_UNITS_SOLD', 'YAHOO_GEO_TARGETS', 'PAID_AND_ORGANIC_QUERIES', 'DFA_REVENUE_CROSS_ENV', 'PRODUCT_TARGET_MIN_BID', 'DATE', 'BID_STRATEGY', 'VISIT_ID', 'DELIVERY_METHOD', 'AD_DISPLAY_URL', 'SEARCH_RANK_LOST_ABSOLUTE_TOP_IMPRESSION_SHARE', 'MONTHLY_BUDGET', 'AD_HEADLINE_2', 'BID_STRATEGY_INHERITED', 'KEYWORD_ENGINE_ID', 'SITELINK_LANDING_PAGE_URL', 'AD_HEADLINE_3', 'AD_PATH_FIELD_2', 'KEYWORD_ID', 'AD_PATH_FIELD_1', 'PRODUCT_COLOR', 'UNCLASSIFIED_TARGET_NAME', 'FEED_ID', 'AD_PROMOTION_LINE', 'FLOODLIGHT_GROUP', 'GENDER_TARGET_GENDER_TYPE', 'KEYWORD_LABELS', 'IS_UNATTRIBUTED_AD', 'KEYWORD_CLICKSERVER_URL', 'COST', 'CROSS_SELL_UNITS_SOLD', 'FLOODLIGHT_REFERRER', 'DFA_WEIGHTED_ACTIONS_CROSS_ENV', 'COST_WITH_FEED_ITEM_SHOWING', 'DEVICE_SEGMENT', 'CALL_PHONE_NUMBER', 'DFA_TRANSACTIONS_CROSS_ENV', 'PRODUCT_TARGET_CLICKSERVER_URL', 'ENGINE_REMARKETING_LIST_BID_MODIFIER', 'PRODUCT_ID', 'ADWORDS_CONVERSION_VALUE', 'KEYWORD_MAXB_ID', 'PRODUCT_BRAND', 'NEGATIVE_AD_GROUP_KEYWORD_TEXT', 'CPA_TARGET', 'SITELINK_DESCRIPTION_2', 'AD_GROUP_START_DATE', 'SITELINK_DESCRIPTION_1', 'DFA_WEIGHTED_ACTIONS', 'CALL_CALL_ONLY', 'DISPLAY_RANK_LOST_IMPRESSION_SHARE')")
        return value

    @field_validator('report_type')
    def report_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('AD', 'PAID_AND_ORGANIC', 'PRODUCT_GROUP', 'CAMPAIGN_TARGET', 'CONVERSION', 'FEED_ITEM', 'NEGATIVE_CAMPAIGN_KEYWORD', 'KEYWORD', 'PRODUCT_TARGET', 'NEGATIVE_AD_GROUP_TARGET', 'PRODUCT_LEAD_AND_CROSS_SELL', 'FLOODLIGHT_ACTIVITY', 'ADGROUP', 'ACCOUNT', 'ADGROUP_TARGET', 'NEGATIVE_CAMPAIGN_TARGET', 'BID_STRATEGY', 'PRODUCT_ADVERTISED', 'VISIT', 'NEGATIVE_AD_GROUP_KEYWORD', 'ADVERTISER', 'CAMPAIGN'):
            raise ValueError("must be one of enum values ('AD', 'PAID_AND_ORGANIC', 'PRODUCT_GROUP', 'CAMPAIGN_TARGET', 'CONVERSION', 'FEED_ITEM', 'NEGATIVE_CAMPAIGN_KEYWORD', 'KEYWORD', 'PRODUCT_TARGET', 'NEGATIVE_AD_GROUP_TARGET', 'PRODUCT_LEAD_AND_CROSS_SELL', 'FLOODLIGHT_ACTIVITY', 'ADGROUP', 'ACCOUNT', 'ADGROUP_TARGET', 'NEGATIVE_CAMPAIGN_TARGET', 'BID_STRATEGY', 'PRODUCT_ADVERTISED', 'VISIT', 'NEGATIVE_AD_GROUP_KEYWORD', 'ADVERTISER', 'CAMPAIGN')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GoogleSearchAds360ConfigV1ConfigReportsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GoogleSearchAds360ConfigV1ConfigReportsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "attributes": obj.get("attributes"),
            "metrics": obj.get("metrics"),
            "report_type": obj.get("report_type"),
            "table": obj.get("table")
        })
        return _obj


