# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GoogleSearchConsoleConfigV1ConfigReportsInner(BaseModel):
    """
    The list of reports. Each report corresponds to a table within the schema to which connector syncs the data.
    """ # noqa: E501
    aggregation: Optional[Dict[str, Any]] = Field(default=None, description="(Optional) Aggregation type. Supported only for the `SEARCH_RESULTS` report type")
    report_type: Optional[Dict[str, Any]] = Field(default=None, description="The type of report")
    search_types: Optional[List[Dict[str, Any]]] = Field(default=None, description="Search types included to sync. Supported only for the `SEARCH_RESULTS` report type")
    table: Optional[StrictStr] = Field(default=None, description="The name of a table within the schema to which connector syncs the data of a given report.")
    dimensions: Optional[List[Dict[str, Any]]] = Field(default=None, description="The report dimensions included to sync.")
    __properties: ClassVar[List[str]] = ["aggregation", "report_type", "search_types", "table", "dimensions"]

    @field_validator('aggregation')
    def aggregation_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('BY_PROPERTY', 'BY_PAGE'):
            raise ValueError("must be one of enum values ('BY_PROPERTY', 'BY_PAGE')")
        return value

    @field_validator('report_type')
    def report_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('DISCOVER', 'GOOGLE_NEWS', 'SEARCH_RESULTS'):
            raise ValueError("must be one of enum values ('DISCOVER', 'GOOGLE_NEWS', 'SEARCH_RESULTS')")
        return value

    @field_validator('search_types')
    def search_types_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        for i in value:
            if i not in ('IMAGE', 'WEB', 'VIDEO', 'NEWS', 'DISCOVER', 'GOOGLE_NEWS'):
                raise ValueError("each list item must be one of ('IMAGE', 'WEB', 'VIDEO', 'NEWS', 'DISCOVER', 'GOOGLE_NEWS')")
        return value

    @field_validator('dimensions')
    def dimensions_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        for i in value:
            if i not in ('DATE', 'COUNTRY', 'QUERY', 'DEVICE', 'PAGE'):
                raise ValueError("each list item must be one of ('DATE', 'COUNTRY', 'QUERY', 'DEVICE', 'PAGE')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GoogleSearchConsoleConfigV1ConfigReportsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GoogleSearchConsoleConfigV1ConfigReportsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "aggregation": obj.get("aggregation"),
            "report_type": obj.get("report_type"),
            "search_types": obj.get("search_types"),
            "table": obj.get("table"),
            "dimensions": obj.get("dimensions")
        })
        return _obj


