# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class LinkedinAdsConfigV1Config(BaseModel):
    """
    
    """ # noqa: E501
    sync_mode: Optional[Dict[str, Any]] = Field(default=None, description="Whether to sync all accounts or specific accounts. Default value: `AllAccounts`")
    var_schema: Optional[StrictStr] = Field(default=None, description="Destination schema. Schema is permanent and cannot be changed after connection creation", alias="schema")
    reports: Optional[List[StrictStr]] = Field(default=None, description="Specific analytics reports to sync. Must be populated if adAnalytics is set to 'SpecificReports'.")
    post_click_attribution_window_size: Optional[Dict[str, Any]] = Field(default=None, description="The time period to attribute conversions based on clicks. Default value: `DAY_30`")
    ad_analytics: Optional[Dict[str, Any]] = Field(default=None, description="Whether to sync all analytic reports or specific. Default value: `AllReports`")
    timeframe_months: Optional[Dict[str, Any]] = Field(default=None, description="Number of months for which to query reporting data included in the initial sync. This number cannot be modified once the connector is created. Default value: `ALL_TIME`.")
    view_through_attribution_window_size: Optional[Dict[str, Any]] = Field(default=None, description="The time period to attribute conversions based on views. Default value: `DAY_7`")
    accounts: Optional[List[StrictStr]] = Field(default=None, description="Specific Account IDs to sync. Must be populated if `syncMode` is set to `SpecificAccounts`.")
    __properties: ClassVar[List[str]] = ["sync_mode", "schema", "reports", "post_click_attribution_window_size", "ad_analytics", "timeframe_months", "view_through_attribution_window_size", "accounts"]

    @field_validator('sync_mode')
    def sync_mode_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('AllAccounts', 'SpecificAccounts'):
            raise ValueError("must be one of enum values ('AllAccounts', 'SpecificAccounts')")
        return value

    @field_validator('post_click_attribution_window_size')
    def post_click_attribution_window_size_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('DAY_1', 'DAY_30', 'DAY_7', 'DAY_28'):
            raise ValueError("must be one of enum values ('DAY_1', 'DAY_30', 'DAY_7', 'DAY_28')")
        return value

    @field_validator('ad_analytics')
    def ad_analytics_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('SpecificReports', 'AllReports'):
            raise ValueError("must be one of enum values ('SpecificReports', 'AllReports')")
        return value

    @field_validator('timeframe_months')
    def timeframe_months_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('TWENTY_FOUR', 'SIX', 'ALL_TIME', 'TWELVE', 'THREE'):
            raise ValueError("must be one of enum values ('TWENTY_FOUR', 'SIX', 'ALL_TIME', 'TWELVE', 'THREE')")
        return value

    @field_validator('view_through_attribution_window_size')
    def view_through_attribution_window_size_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('DAY_1', 'DAY_30', 'DAY_7', 'DAY_28'):
            raise ValueError("must be one of enum values ('DAY_1', 'DAY_30', 'DAY_7', 'DAY_28')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LinkedinAdsConfigV1Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LinkedinAdsConfigV1Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sync_mode": obj.get("sync_mode"),
            "schema": obj.get("schema"),
            "reports": obj.get("reports"),
            "post_click_attribution_window_size": obj.get("post_click_attribution_window_size"),
            "ad_analytics": obj.get("ad_analytics"),
            "timeframe_months": obj.get("timeframe_months"),
            "view_through_attribution_window_size": obj.get("view_through_attribution_window_size"),
            "accounts": obj.get("accounts")
        })
        return _obj


