# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, SecretStr, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class MarketoConfigV1Config(BaseModel):
    """
    
    """ # noqa: E501
    soap_uri: Optional[StrictStr] = Field(default=None, description="Marketo SOAP API Endpoint.")
    var_schema: Optional[StrictStr] = Field(default=None, description="Destination schema. Schema is permanent and cannot be changed after connection creation", alias="schema")
    endpoint: Optional[StrictStr] = Field(default=None, description="Marketo REST API endpoint.")
    are_soap_credentials_provided: Optional[StrictBool] = Field(default=None, description="Marketo SOAP credentials provided.")
    user_id: Optional[StrictStr] = Field(default=None, description="Marketo SOAP API User Id.")
    identity: Optional[StrictStr] = Field(default=None, description="Marketo REST API identity url.")
    api_quota: Optional[StrictInt] = Field(default=None, description="Allowed number of API requests to Marketo instance per day, the default value is 10000.")
    encryption_key: Optional[SecretStr] = Field(default=None, description="Marketo SOAP API Encryption Key.")
    client_secret: Optional[SecretStr] = Field(default=None, description="Marketo REST API Client Secret.")
    client_id: Optional[StrictStr] = Field(default=None, description="Marketo REST API Client Id.")
    __properties: ClassVar[List[str]] = ["soap_uri", "schema", "endpoint", "are_soap_credentials_provided", "user_id", "identity", "api_quota", "encryption_key", "client_secret", "client_id"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MarketoConfigV1Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MarketoConfigV1Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "soap_uri": obj.get("soap_uri"),
            "schema": obj.get("schema"),
            "endpoint": obj.get("endpoint"),
            "are_soap_credentials_provided": obj.get("are_soap_credentials_provided"),
            "user_id": obj.get("user_id"),
            "identity": obj.get("identity"),
            "api_quota": obj.get("api_quota"),
            "encryption_key": obj.get("encryption_key"),
            "client_secret": obj.get("client_secret"),
            "client_id": obj.get("client_id")
        })
        return _obj


