# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.aurora_warehouse_config_v1_config import AuroraWarehouseConfigV1Config
from openapi_client.models.new_destination_request import NewDestinationRequest
from typing import Optional, Set
from typing_extensions import Self

class MysqlWarehouseNewDestinationRequest(NewDestinationRequest):
    """
    MysqlWarehouseNewDestinationRequest
    """ # noqa: E501
    config: Optional[AuroraWarehouseConfigV1Config] = None
    __properties: ClassVar[List[str]] = ["group_id", "service", "region", "time_zone_offset", "trust_certificates", "trust_fingerprints", "run_setup_tests", "config"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MysqlWarehouseNewDestinationRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of config
        if self.config:
            _dict['config'] = self.config.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MysqlWarehouseNewDestinationRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "group_id": obj.get("group_id"),
            "service": obj.get("service"),
            "region": obj.get("region"),
            "time_zone_offset": obj.get("time_zone_offset"),
            "trust_certificates": obj.get("trust_certificates"),
            "trust_fingerprints": obj.get("trust_fingerprints"),
            "run_setup_tests": obj.get("run_setup_tests"),
            "config": AuroraWarehouseConfigV1Config.from_dict(obj["config"]) if obj.get("config") is not None else None
        })
        return _obj


