# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, SecretStr, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class OnelakeConfigV1Config(BaseModel):
    """
    
    """ # noqa: E501
    tenant_id: Optional[StrictStr] = Field(default=None, description="Tenant ID of service principal")
    container_name: Optional[StrictStr] = Field(default=None, description="Workspace name to store delta table files")
    storage_account_name: Optional[StrictStr] = Field(default=None, description="Storage account for Azure Data Lake Storage Gen2 name")
    secret_value: Optional[SecretStr] = Field(default=None, description="Secret value for service principal")
    lakehouse_name: Optional[StrictStr] = Field(default=None, description="Name of your lakehouse")
    client_id: Optional[StrictStr] = Field(default=None, description="Client ID of service principal")
    prefix_path: Optional[StrictStr] = Field(default=None, description="path/to/data within your lakehouse inside the Files directory")
    __properties: ClassVar[List[str]] = ["tenant_id", "container_name", "storage_account_name", "secret_value", "lakehouse_name", "client_id", "prefix_path"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OnelakeConfigV1Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OnelakeConfigV1Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "tenant_id": obj.get("tenant_id"),
            "container_name": obj.get("container_name"),
            "storage_account_name": obj.get("storage_account_name"),
            "secret_value": obj.get("secret_value"),
            "lakehouse_name": obj.get("lakehouse_name"),
            "client_id": obj.get("client_id"),
            "prefix_path": obj.get("prefix_path")
        })
        return _obj


