# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, SecretStr, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class SegmentConfigV1Config(BaseModel):
    """
    
    """ # noqa: E501
    bucket: Optional[StrictStr] = Field(default=None, description="The name of the Segment bucket. Must be populated if `sync_type` is set to `S3`.")
    var_schema: Optional[StrictStr] = Field(default=None, description="Destination schema. Schema is permanent and cannot be changed after connection creation", alias="schema")
    role_arn: Optional[SecretStr] = Field(default=None, description="The Role ARN required for authentication. Must be populated if `sync_type` is set to `S3`.")
    webhook_url: Optional[StrictStr] = Field(default=None, description="Webhook URL.")
    sync_type: Optional[Dict[str, Any]] = Field(default=None, description="The Segment connector sync type.")
    prefix: Optional[StrictStr] = Field(default=None, description="Folder path to the Segment files within the bucket. Must be populated if `sync_type` is set to `S3`.")
    external_id: Optional[StrictStr] = Field(default=None, description="The external ID is a string that designates who can assume the role. For more information, see <a href=\"http://docs.aws.amazon.com/IAM/latest/UserGuide/id_roles_create_for-user_externalid.html\">Amazon's AWS Identity and Access Management User Guide</a>.")
    __properties: ClassVar[List[str]] = ["bucket", "schema", "role_arn", "webhook_url", "sync_type", "prefix", "external_id"]

    @field_validator('sync_type')
    def sync_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('S3', 'Webhook'):
            raise ValueError("must be one of enum values ('S3', 'Webhook')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SegmentConfigV1Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SegmentConfigV1Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "bucket": obj.get("bucket"),
            "schema": obj.get("schema"),
            "role_arn": obj.get("role_arn"),
            "webhook_url": obj.get("webhook_url"),
            "sync_type": obj.get("sync_type"),
            "prefix": obj.get("prefix"),
            "external_id": obj.get("external_id")
        })
        return _obj


