# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.snapchat_ads_config_v1_config_custom_reports_inner import SnapchatAdsConfigV1ConfigCustomReportsInner
from typing import Optional, Set
from typing_extensions import Self

class SnapchatAdsConfigV1Config(BaseModel):
    """
    
    """ # noqa: E501
    sync_mode: Optional[Dict[str, Any]] = Field(default=None, description="Whether to sync all organizations or specific organizations. Default value: `AllOrganizations`.")
    var_schema: Optional[StrictStr] = Field(default=None, description="Destination schema. Schema is permanent and cannot be changed after connection creation", alias="schema")
    view_attribution_window: Optional[Dict[str, Any]] = Field(default=None, description="The time period to attribute conversions based on views. Default value: `DAY_1`")
    swipe_attribution_window: Optional[Dict[str, Any]] = Field(default=None, description="The time period to attribute conversions based on swipes. Default value: `DAY_28`")
    timeframe_months: Optional[Dict[str, Any]] = Field(default=None, description="Number of months' worth of reporting data you'd like to include in your initial sync. This cannot be modified once the connector is created. Default value: `TWELVE`.")
    organizations: Optional[List[StrictStr]] = Field(default=None, description="Specific organizations IDs to sync. Must be populated if `syncMode` is set to `SpecificOrganizations`.")
    custom_reports: Optional[List[SnapchatAdsConfigV1ConfigCustomReportsInner]] = Field(default=None, description="[Custom reports for Snapchat Ads connector](/docs/applications/snapchat-ads/custom-reports).")
    __properties: ClassVar[List[str]] = ["sync_mode", "schema", "view_attribution_window", "swipe_attribution_window", "timeframe_months", "organizations", "custom_reports"]

    @field_validator('sync_mode')
    def sync_mode_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('SpecificOrganizations', 'AllOrganizations'):
            raise ValueError("must be one of enum values ('SpecificOrganizations', 'AllOrganizations')")
        return value

    @field_validator('view_attribution_window')
    def view_attribution_window_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('DAY_1', 'HOUR_6', 'HOUR_3', 'HOUR_1', 'DAY_7', 'NONE', 'DAY_28'):
            raise ValueError("must be one of enum values ('DAY_1', 'HOUR_6', 'HOUR_3', 'HOUR_1', 'DAY_7', 'NONE', 'DAY_28')")
        return value

    @field_validator('swipe_attribution_window')
    def swipe_attribution_window_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('DAY_1', 'DAY_7', 'DAY_28'):
            raise ValueError("must be one of enum values ('DAY_1', 'DAY_7', 'DAY_28')")
        return value

    @field_validator('timeframe_months')
    def timeframe_months_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('TWENTY_FOUR', 'SIX', 'ALL_TIME', 'TWELVE', 'THREE'):
            raise ValueError("must be one of enum values ('TWENTY_FOUR', 'SIX', 'ALL_TIME', 'TWELVE', 'THREE')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SnapchatAdsConfigV1Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in custom_reports (list)
        _items = []
        if self.custom_reports:
            for _item in self.custom_reports:
                if _item:
                    _items.append(_item.to_dict())
            _dict['custom_reports'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SnapchatAdsConfigV1Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sync_mode": obj.get("sync_mode"),
            "schema": obj.get("schema"),
            "view_attribution_window": obj.get("view_attribution_window"),
            "swipe_attribution_window": obj.get("swipe_attribution_window"),
            "timeframe_months": obj.get("timeframe_months"),
            "organizations": obj.get("organizations"),
            "custom_reports": [SnapchatAdsConfigV1ConfigCustomReportsInner.from_dict(_item) for _item in obj["custom_reports"]] if obj.get("custom_reports") is not None else None
        })
        return _obj


