# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class UserResponse(BaseModel):
    """
    UserResponse
    """ # noqa: E501
    id: StrictStr = Field(description="The unique identifier for the user within the Fivetran system.")
    email: StrictStr = Field(description="The email address that the user has associated with their user profile.")
    verified: StrictBool = Field(description="The field indicates whether the user has verified their email address in the account creation process.")
    invited: Optional[StrictBool] = Field(default=None, description="The field indicates whether the user has been invited to your account.")
    picture: Optional[StrictStr] = Field(default=None, description="The user's avatar as a URL link (for example, 'http://mycompany.com/avatars/john_white.png') or base64 data URI (for example, 'data:image/png;base64,aHR0cDovL215Y29tcGFueS5jb20vYXZhdGFycy9qb2huX3doaXRlLnBuZw==')")
    phone: Optional[StrictStr] = Field(default=None, description="The phone number of the user.")
    role: StrictStr = Field(description="The role that you would like to assign to the user ")
    active: StrictBool = Field(description="The field indicates if the user is an active Fivetran account user.")
    given_name: Optional[StrictStr] = Field(default=None, description="The first name of the user.")
    created_at: datetime = Field(description="The timestamp that the user created their Fivetran account")
    family_name: Optional[StrictStr] = Field(default=None, description="The last name of the user.")
    logged_in_at: datetime = Field(description="The last time that the user has logged into their Fivetran account.")
    __properties: ClassVar[List[str]] = ["id", "email", "verified", "invited", "picture", "phone", "role", "active", "given_name", "created_at", "family_name", "logged_in_at"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UserResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UserResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "email": obj.get("email"),
            "verified": obj.get("verified"),
            "invited": obj.get("invited"),
            "picture": obj.get("picture"),
            "phone": obj.get("phone"),
            "role": obj.get("role"),
            "active": obj.get("active"),
            "given_name": obj.get("given_name"),
            "created_at": obj.get("created_at"),
            "family_name": obj.get("family_name"),
            "logged_in_at": obj.get("logged_in_at")
        })
        return _obj


