# coding: utf-8

"""
    OpenAPI Definition

    The OpenAPI Specification is a standard format to define the structure and syntax of REST APIs. OpenAPI documents are both machine and human-readable, which enables anyone to easily determine how each API works. [More details](https://www.openapis.org/faq)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.yahoo_dsp_config_v1_config_report_configs_inner import YahooDspConfigV1ConfigReportConfigsInner
from typing import Optional, Set
from typing_extensions import Self

class YahooDspConfigV1Config(BaseModel):
    """
    
    """ # noqa: E501
    var_schema: Optional[StrictStr] = Field(default=None, description="Destination schema. Schema is permanent and cannot be changed after connection creation", alias="schema")
    sync_mode_advertiser: Optional[Dict[str, Any]] = Field(default=None, description="Whether to sync all advertisers or specific advertisers. Default value: `ALL_ADVERTISERS`.")
    advertisers_with_seat: Optional[List[StrictStr]] = Field(default=None, description="Specific Advertisers to sync. Must be populated if `sync_mode_advertiser` is set to `SPECIFIC_ADVERTISERS`. Pay attention to the format: `AdvertiserId:SeatId`")
    timeframe_months: Optional[Dict[str, Any]] = Field(default=None, description="Number of months` worth of reporting data you'd like to include in your initial sync. This cannot be modified once the connector is created. Default value: `THREE`.")
    report_configs: Optional[List[YahooDspConfigV1ConfigReportConfigsInner]] = Field(default=None, description="Specify the reports you want to sync. This is optional.")
    sync_mode_seat: Optional[Dict[str, Any]] = Field(default=None, description="Whether to sync all seats or specific seats. Default value: `ALL_SEATS`.")
    seats: Optional[List[StrictInt]] = Field(default=None, description="Specific Seats to sync. Must be populated if `sync_mode_seat` is set to `SPECIFIC_SEATS`.")
    __properties: ClassVar[List[str]] = ["schema", "sync_mode_advertiser", "advertisers_with_seat", "timeframe_months", "report_configs", "sync_mode_seat", "seats"]

    @field_validator('sync_mode_advertiser')
    def sync_mode_advertiser_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('SPECIFIC_ADVERTISERS', 'ALL_ADVERTISERS'):
            raise ValueError("must be one of enum values ('SPECIFIC_ADVERTISERS', 'ALL_ADVERTISERS')")
        return value

    @field_validator('timeframe_months')
    def timeframe_months_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('TWENTY_FOUR', 'SIX', 'ALL_TIME', 'TWELVE', 'THREE'):
            raise ValueError("must be one of enum values ('TWENTY_FOUR', 'SIX', 'ALL_TIME', 'TWELVE', 'THREE')")
        return value

    @field_validator('sync_mode_seat')
    def sync_mode_seat_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('ALL_SEATS', 'SPECIFIC_SEATS'):
            raise ValueError("must be one of enum values ('ALL_SEATS', 'SPECIFIC_SEATS')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of YahooDspConfigV1Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in report_configs (list)
        _items = []
        if self.report_configs:
            for _item in self.report_configs:
                if _item:
                    _items.append(_item.to_dict())
            _dict['report_configs'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of YahooDspConfigV1Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "schema": obj.get("schema"),
            "sync_mode_advertiser": obj.get("sync_mode_advertiser"),
            "advertisers_with_seat": obj.get("advertisers_with_seat"),
            "timeframe_months": obj.get("timeframe_months"),
            "report_configs": [YahooDspConfigV1ConfigReportConfigsInner.from_dict(_item) for _item in obj["report_configs"]] if obj.get("report_configs") is not None else None,
            "sync_mode_seat": obj.get("sync_mode_seat"),
            "seats": obj.get("seats")
        })
        return _obj


